/* FUSE(FastUpSamplingEngin) was written by choi on Nov.23,2004.
 *                                   (this version: Jan.7,2007)
 * You can contact them at http://sak2-2.tok2.com/home/choi/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#ifdef unix
#include <sys/stat.h>
#include <sys/types.h>
#else
#include <conio.h>
#include <direct.h>
#endif

#include "convolution.h"

#include "define.h"
#include "printmessage.h"
#include "cputype.h"
#include "fftw3.h"

#ifdef unix
#define DIRSEPARATOR "/"
#else
#define DIRSEPARATOR "\\"
#endif

//double *in_r2r_dbl,*out_r2r_dbl;
char* wisdom_dir_cp;

//cdirection
/*void* init_conv(
	char* fuseexe_cp,
	int precision_int,
	char* transform_kind_cp,
	int main_or_sidelobe_int,
	int direction_int,
	int optimize_int,
	int fft_block_length_int,
	void* in,void* out)
*/
#define DEBUGPRINT

void init_conv(Fftv* a)
{
	//m in
	if(a->in_malloc_int==ALLOCATE_MEMORY){
		#ifdef DEBUGPRINT
			printf("a->in_malloc_int start******* \n");
		#endif
		
		switch(a->precision_int){
			case FLOAT_PRECISION:
				if(	!strcmp(a->transform_kind_cp,DFT) ){
					a->in  = (fftwf_complex*)fftwf_malloc( sizeof(fftwf_complex) * a->fft_block_length_int);
				}
				if(	!strcmp(a->transform_kind_cp,REAL2REAL) ){
	    			a->in  = (float*)fftwf_malloc( sizeof(float) * a->fft_block_length_int);
				}
				a->in_malloc_int=DONT_ALLOCATE_MEMORY;		
				break;
			case DOUBLE_PRECISION:
				if(	!strcmp(a->transform_kind_cp,DFT) ){
					a->in  = (fftw_complex*)fftw_malloc( sizeof(fftw_complex) * a->fft_block_length_int);
				}
				if(	!strcmp(a->transform_kind_cp,REAL2REAL) ){
	    			a->in  = (double*)fftw_malloc( sizeof(double) * a->fft_block_length_int);
				}
				a->in_malloc_int=DONT_ALLOCATE_MEMORY;		
				break;
			case LONG_DOUBLE_PRECISION:
				if(	!strcmp(a->transform_kind_cp,DFT) ){
					a->in  = (fftwl_complex*)fftwl_malloc( sizeof(fftwl_complex) * a->fft_block_length_int);
				}
				if(	!strcmp(a->transform_kind_cp,REAL2REAL) ){
	    			a->in  = (long double*)fftwl_malloc( sizeof(long double) * a->fft_block_length_int);
				}
				a->in_malloc_int=DONT_ALLOCATE_MEMORY;		
				break;
		}
	}
	
	//m out
	if(a->out_malloc_int==ALLOCATE_MEMORY){
		#ifdef DEBUGPRINT
			printf("a->out_malloc_int start******* \n");
		#endif
		
		switch(a->precision_int){
			case FLOAT_PRECISION:
				if(	!strcmp(a->transform_kind_cp,DFT) ){
	    			a->out = (fftwf_complex*)fftwf_malloc( sizeof(fftwf_complex) * a->fft_block_length_int);
				}
				if(	!strcmp(a->transform_kind_cp,REAL2REAL) ){
	    			a->out = (float*)fftwf_malloc( sizeof(float) * a->fft_block_length_int);
				}
				a->out_malloc_int=DONT_ALLOCATE_MEMORY;		
				break;
			case DOUBLE_PRECISION:
				if(	!strcmp(a->transform_kind_cp,DFT) ){
	    			a->out = (fftw_complex*)fftw_malloc( sizeof(fftw_complex) * a->fft_block_length_int);
				}
				if(	!strcmp(a->transform_kind_cp,REAL2REAL) ){
	    			a->out = (double*)fftw_malloc( sizeof(double) * a->fft_block_length_int);
				}
				a->out_malloc_int=DONT_ALLOCATE_MEMORY;		
				break;
			case LONG_DOUBLE_PRECISION:
				if(	!strcmp(a->transform_kind_cp,DFT) ){
	    			a->out = (fftwl_complex*)fftwl_malloc( sizeof(fftwl_complex) * a->fft_block_length_int);
				}
				if(	!strcmp(a->transform_kind_cp,REAL2REAL) ){
	    			a->out = (long double*)fftwl_malloc( sizeof(long double) * a->fft_block_length_int);
				}
				a->out_malloc_int=DONT_ALLOCATE_MEMORY;		
				break;			
		}
	}

//	if(a->in_malloc_int ){	printf("inaaaaaaaaaaaaaaaaaaaaaaaa");}
//	if(a->out_malloc_int){	printf("outaaaaaaaaaaaaaaaaaaaaaaaa");}

	
	//char *wisdom_dir_cp     ;
	wisdom_dir_cp     = (char *)calloc(FILENAME_BUF_SIZE,sizeof(char));if(wisdom_dir_cp      == NULL) { printMessage_int(MALLOC_ERROR); exit(1);}
	//char *wisdom_filename_cp;
	a->wisdom_filename_cp = (char *)calloc(FILENAME_BUF_SIZE,sizeof(char));if(a->wisdom_filename_cp == NULL) { printMessage_int(MALLOC_ERROR); exit(1);}
	//char *wisdom_string_cp  ;
	a->wisdom_string_cp = (char *)calloc(WISDOM_BUF_SIZE,sizeof(char))  ;if(a->wisdom_string_cp   == NULL) { printMessage_int(MALLOC_ERROR); exit(1);}

	char* wisdom_direction_cp=WISDOMDIRECTIONFORWARDSUFFIX;
	if(a->direction_int==BW){wisdom_direction_cp=WISDOMDIRECTIONBACKWARDSUFFIX;}

//	a->fft_block_length_int=(int)pow(2,fft_block_power_int);

 //wisdomt@C̏(́AwavƓfBNgɍ)
	int last_dir_int=0;
  	for(int tmp_dir_int=0;tmp_dir_int<(int)strlen(a->fuseexe_cp);tmp_dir_int++){
    	if(a->fuseexe_cp[tmp_dir_int]==0x5c){last_dir_int=tmp_dir_int;}
  	}
#ifdef unix
	strcpy(wisdom_dir_cp,"./");
#else
	strcpy(wisdom_dir_cp,a->fuseexe_cp);
  	wisdom_dir_cp[last_dir_int+1]=0x00;
#endif
  	strcat(wisdom_dir_cp,WISDOMDIRNAME);
	
	char* transform_kind_suffix_cp=TRANSFORMKINDR2RSUFFIX;
	if(	!strcmp(a->transform_kind_cp,DFT)){transform_kind_suffix_cp=TRANSFORMKINDDFTSUFFIX;}

	char* precision_suffix_cp=LDOUBLEPRECISIONSUFFIX;
	int fft_block_power_int=(int)log2((double)a->fft_block_length_int);
	switch(a->precision_int){
	case FLOAT_PRECISION:
		precision_suffix_cp=FLOATPRECISIONSUFFIX;
		sprintf(a->wisdom_filename_cp,"%s%s%s%s_%s%s_o%d_b%d%s.wisdom",wisdom_dir_cp,DIRSEPARATOR,fftwf_version,precision_suffix_cp,GetCpuID_cp(),transform_kind_suffix_cp,a->optimize_int,fft_block_power_int,wisdom_direction_cp);
		break;
	case DOUBLE_PRECISION:
		precision_suffix_cp=DOUBLEPRECISIONSUFFIX;
		sprintf(a->wisdom_filename_cp,"%s%s%s%s_%s%s_o%d_b%d%s.wisdom",wisdom_dir_cp,DIRSEPARATOR,fftw_version,precision_suffix_cp,GetCpuID_cp(),transform_kind_suffix_cp,a->optimize_int,fft_block_power_int,wisdom_direction_cp);
		break;
	case LONG_DOUBLE_PRECISION:
		precision_suffix_cp=LDOUBLEPRECISIONSUFFIX;
		sprintf(a->wisdom_filename_cp,"%s%s%s%s_%s%s_o%d_b%d%s.wisdom",wisdom_dir_cp,DIRSEPARATOR,fftwl_version,precision_suffix_cp,GetCpuID_cp(),transform_kind_suffix_cp,a->optimize_int,fft_block_power_int,wisdom_direction_cp);
		break;
	}

#ifdef DEBUGPRINT
	printf("%s\n",a->wisdom_filename_cp);
#endif

#ifdef unix
	mkdir(wisdom_dir_cp,0755);
#else
	mkdir(wisdom_dir_cp);
#endif

	int	save_wisdom_int=NOTSAVE_WISDOM;
	FILE* fft_plan_Fp;

	if(a->optimize_int > 0){
		if ((fft_plan_Fp = fopen(a->wisdom_filename_cp, "rb")) == NULL){
			if ((fft_plan_Fp = fopen(a->wisdom_filename_cp, "wb")) == NULL) { printMessage_int(MALLOC_ERROR); exit(1);}//t@Copen errorɕς邱
			save_wisdom_int=SAVE_WISDOM;//wisdomĐݒtO

		}else{	//wisdomt@Cꍇ
			//ǂ
			fread(a->wisdom_string_cp
				,sizeof(char),WISDOM_BUF_SIZE-1,fft_plan_Fp);fclose(fft_plan_Fp);

			if(strlen(a->wisdom_string_cp)<WISDOM_ERROR_MIN){  //sǃt@C){
			//wisdomt@Csǂ̏ꍇ
				if ((fft_plan_Fp = fopen(a->wisdom_filename_cp, "wb")) == NULL) { printMessage_int(MALLOC_ERROR); exit(1);}//t@Copen errorɕς邱
				save_wisdom_int=SAVE_WISDOM;//wisdomĐݒtO
			}else{	//wisdomt@C̏ꍇ

				#ifdef DEBUGPRINT
					printf("strlen wisdom %d\n",strlen(a->wisdom_string_cp) );
				#endif
			
//				fftw_import_wisdom_from_string(a->wisdom_string_cp);

				#ifdef DEBUGPRINT
					printf("read wisdom correctly\n");
					print_wisdom(a);
				#endif
			}
		}
	}
	
	#ifdef DEBUGPRINT
		if(	!strcmp(a->transform_kind_cp,DFT) ){printf("malloc %lfMB %d im_int\n",(double)a->fft_block_length_int/1024/1024*sizeof(a->in)*2*4,a->fft_block_length_int);}
		if(	!strcmp(a->transform_kind_cp,REAL2REAL) ){printf("malloc %lfMB %d im_int\n",(double)a->fft_block_length_int/1024/1024*sizeof(a->in)*2,a->fft_block_length_int);}
		//getch();	
	#endif

	unsigned int optimize_flag_ui=DEFAULT_OPTIMIZE_FLAG;

	switch(a->optimize_int){
	case 0:
		optimize_flag_ui+=FFTW_ESTIMATE;
		#ifdef DEBUGPRINT
			printf("FFTW_ESTIMATE\n");
		#endif
		break;
	case 1:
		optimize_flag_ui+=FFTW_MEASURE;
		#ifdef DEBUGPRINT
			printf("FFTW_MEASURE\n");
		#endif
		break;
	case 2:
		optimize_flag_ui+=FFTW_PATIENT;
		#ifdef DEBUGPRINT
			printf("FFTW_PATIENT\n");
		#endif
		break;
	case 3:
		optimize_flag_ui+=FFTW_EXHAUSTIVE;
		#ifdef DEBUGPRINT
			printf("FFTW_EXHAUSTIVE\n");
		#endif
		break;
	}
	#ifdef DEBUGPRINT
		printf("optimize_int %d\n",a->optimize_int);
		printf("optimize_flag_ui %u\n",optimize_flag_ui);
//		optimize_flag_ui+=FFTW_MEASURE;
	
		printf("fftw_plan start\n");
	#endif

//	if(save_wisdom_int==NOTSAVE_WISDOM)fftw_import_wisdom_from_string(a->wisdom_string_cp);
	switch(a->precision_int){
		case FLOAT_PRECISION:
		if((save_wisdom_int==NOTSAVE_WISDOM) && (a->optimize_int > 0))fftwf_import_wisdom_from_string(a->wisdom_string_cp);
		if(a->direction_int==FW){
			if(	!strcmp(a->transform_kind_cp,DFT) )
				{a->fftwplan
					=fftwf_plan_dft_1d(a->fft_block_length_int,(fftwf_complex*)a->in,(fftwf_complex*)a->out,FFTW_FORWARD,optimize_flag_ui);}
			else{a->fftwplan
					=fftwf_plan_r2r_1d(a->fft_block_length_int,(float*)a->in,(float*)a->out,FFTW_R2HC,optimize_flag_ui);}
		}else{
			if(	!strcmp(a->transform_kind_cp,DFT) )
				{a->fftwplan
					=fftwf_plan_dft_1d(a->fft_block_length_int,(fftwf_complex*)a->out,(fftwf_complex*)a->in,FFTW_BACKWARD,optimize_flag_ui);}
			else{a->fftwplan
					=fftwf_plan_r2r_1d(a->fft_block_length_int,(float*)a->out,(float*)a->in,FFTW_HC2R,optimize_flag_ui);}
				printf("backr2r++++++++++++++++++\n");
		}
		if(save_wisdom_int==SAVE_WISDOM){
			printf("%s",fftwf_export_wisdom_to_string());//aaa
			a->wisdom_string_cp=fftwf_export_wisdom_to_string();
    		fprintf(fft_plan_Fp,"%s\0",a->wisdom_string_cp);
			fclose(fft_plan_Fp);}
		break;

	case DOUBLE_PRECISION:
		if((save_wisdom_int==NOTSAVE_WISDOM) && (a->optimize_int > 0))fftw_import_wisdom_from_string(a->wisdom_string_cp);
		if(a->direction_int==FW){
			if(	!strcmp(a->transform_kind_cp,DFT) )
				{a->fftwplan 
					=fftw_plan_dft_1d(a->fft_block_length_int,(fftw_complex*)a->in,(fftw_complex*)a->out,FFTW_FORWARD,optimize_flag_ui);}
			else{a->fftwplan
					=fftw_plan_r2r_1d(a->fft_block_length_int,(double*)a->in,(double*)a->out,FFTW_R2HC,optimize_flag_ui);}
		}else{
			if(	!strcmp(a->transform_kind_cp,DFT) )
				{a->fftwplan 
					=fftw_plan_dft_1d(a->fft_block_length_int,(fftw_complex*)a->out,(fftw_complex*)a->in,FFTW_BACKWARD,optimize_flag_ui);}
			else{a->fftwplan
					=fftw_plan_r2r_1d(a->fft_block_length_int,(double*)a->out,(double*)a->in,FFTW_HC2R,optimize_flag_ui);}
		}
		if(save_wisdom_int==SAVE_WISDOM){
//			printf("%s",fftw_export_wisdom_to_string());//aaa
			a->wisdom_string_cp=fftw_export_wisdom_to_string();

			#ifdef DEBUGPRINT
			   	fprintf(fft_plan_Fp,"%s",a->wisdom_string_cp);
				printf("strlen wisdom %d\n",strlen(a->wisdom_string_cp) );
			#endif
			
			fclose(fft_plan_Fp);
		}
		break;
	case LONG_DOUBLE_PRECISION:
		if((save_wisdom_int==NOTSAVE_WISDOM) && (a->optimize_int > 0))fftwl_import_wisdom_from_string(a->wisdom_string_cp);
		if(a->direction_int==FW){
			if(	!strcmp(a->transform_kind_cp,DFT) )
				{a->fftwplan 
					=fftwl_plan_dft_1d(a->fft_block_length_int,(fftwl_complex*)a->in,(fftwl_complex*)a->out,FFTW_FORWARD,optimize_flag_ui);}
			else{a->fftwplan
					=fftwl_plan_r2r_1d(a->fft_block_length_int,(long double*)a->in,(long double*)a->out,FFTW_R2HC,optimize_flag_ui);}
		}else{
			if(	!strcmp(a->transform_kind_cp,DFT) )
				{a->fftwplan 
					=fftwl_plan_dft_1d(a->fft_block_length_int,(fftwl_complex*)a->out,(fftwl_complex*)a->in,FFTW_BACKWARD,optimize_flag_ui);}
			else{a->fftwplan
					=fftwl_plan_r2r_1d(a->fft_block_length_int,(long double*)a->out,(long double*)a->in,FFTW_HC2R,optimize_flag_ui);}
		}
		if(save_wisdom_int==SAVE_WISDOM){
			//printf("%s",fftwl_export_wisdom_to_string());//aaa
			a->wisdom_string_cp=fftwl_export_wisdom_to_string();
    		fprintf(fft_plan_Fp,"%s",a->wisdom_string_cp);
			fclose(fft_plan_Fp);
		}
		break;
	}
	#ifdef DEBUGPRINT
		printf("%s\n",a->wisdom_string_cp);
		printf("fftw_plan finish\n");
//	getch();
	#endif

}


//(int main_or_sidelobe_int,int direction_int)

void print_wisdom(Fftv* a)
{
		if(a->main_or_sidelobe_int==MAINLOBE)printf("mainlobe:%d\n",a->main_or_sidelobe_int);
		if(a->main_or_sidelobe_int==SIDELOBE)printf("sidelobe:%d\n",a->main_or_sidelobe_int);
		if(a->direction_int==FW)printf("forward:%d\n",a->direction_int);
		if(a->direction_int==BW)printf("backward:%d\n",a->direction_int);

//		printf("%s\n",a->wisdom_filename_cp);
		printf("strlen wisdom %d\n",strlen(a->wisdom_string_cp) );
		
		printf("%s\n",a->wisdom_string_cp);

//		printf("0++++++++++++++++++++++++\n");
//		printf("%s\n",wisdom_string_cp[0]);
//		printf("1++++++++++++++++++++++++\n");
//		printf("%s\n",wisdom_string_cp[1]);

//		printf("2++++++++++++++++++++++++\n");
//		printf("%s\n",wisdom_string_cp[2]);
//		printf("3++++++++++++++++++++++++\n");
//		printf("%s\n",wisdom_string_cp[3]);

		printf("print fin\n");
	
}

//(double* in,double* out)

void print_conv(Fftv* a)
{
	
	for(int i=0;i<a->fft_block_length_int;i++){
		printf("%d %lg %lg\n",i,((double*)a->in)[i],((double*)a->out)[i]);
	}
	
}

void fftexe(Fftv* a)
{
	switch(a->precision_int){
		case FLOAT_PRECISION:
			fftwf_import_wisdom_from_string(a->wisdom_string_cp);
			fftwf_execute( (fftwf_plan)a->fftwplan );
		break;
		case DOUBLE_PRECISION:
			fftw_import_wisdom_from_string(a->wisdom_string_cp);
			fftw_execute( (fftw_plan)a->fftwplan );
		break;
		case LONG_DOUBLE_PRECISION:
			fftwl_import_wisdom_from_string(a->wisdom_string_cp);
			fftwl_execute( (fftwl_plan)a->fftwplan );
		break;	
	}
}

void fftfree(Fftv* a)
{
	//J
	switch(a->precision_int){
		case FLOAT_PRECISION:
			if(a->in_malloc_int==DONT_ALLOCATE_MEMORY){fftwf_free(a->in);a->in_malloc_int=ALLOCATE_MEMORY;}
			if(a->out_malloc_int==DONT_ALLOCATE_MEMORY){fftwf_free(a->out);a->out_malloc_int=ALLOCATE_MEMORY;}
			break;
		case DOUBLE_PRECISION:
			if(a->in_malloc_int==DONT_ALLOCATE_MEMORY){fftw_free(a->in);a->in_malloc_int=ALLOCATE_MEMORY;}
			if(a->out_malloc_int==DONT_ALLOCATE_MEMORY){fftw_free(a->out);a->out_malloc_int=ALLOCATE_MEMORY;}
			break;
		case LONG_DOUBLE_PRECISION:
			if(a->in_malloc_int==DONT_ALLOCATE_MEMORY){fftwl_free(a->in);a->in_malloc_int=ALLOCATE_MEMORY;}
			if(a->out_malloc_int==DONT_ALLOCATE_MEMORY){fftwl_free(a->out);a->out_malloc_int=ALLOCATE_MEMORY;}
			break;
	}
#ifndef unix
	free(wisdom_dir_cp);
#endif
	free(a->wisdom_filename_cp);
	free(a->wisdom_string_cp);
}

void fftinfree(Fftv* a)
{
	//in̂݃J
	switch(a->precision_int){
		case FLOAT_PRECISION:
			if(a->in_malloc_int==DONT_ALLOCATE_MEMORY){fftwf_free(a->in);a->in_malloc_int=ALLOCATE_MEMORY;}
			break;
		case DOUBLE_PRECISION:
			if(a->in_malloc_int==DONT_ALLOCATE_MEMORY){fftw_free(a->in);a->in_malloc_int=ALLOCATE_MEMORY;}
			break;
		case LONG_DOUBLE_PRECISION:
			if(a->in_malloc_int==DONT_ALLOCATE_MEMORY){fftwl_free(a->in);a->in_malloc_int=ALLOCATE_MEMORY;}
			break;
	}
}

void fft_mul(Fftv* a,Fftv* b,Fftv* c)
{
	switch(a->precision_int){
		case FLOAT_PRECISION:
			if(	!strcmp(b->transform_kind_cp,DFT) ){
				fft_mulf_CxC(a,b,c);
			}else{
				if(	!strcmp(a->transform_kind_cp,DFT) ){
					fft_mulf_CxR(a,b,c);
				}else{
					fft_mulf_RxR(a,b,c);
				}
			}
		break;
		case DOUBLE_PRECISION:
			if(	!strcmp(b->transform_kind_cp,DFT) ){
				fft_mul_CxC(a,b,c);
			}else{
				if(	!strcmp(a->transform_kind_cp,DFT) ){
					fft_mul_CxR(a,b,c);
				}else{
					fft_mul_RxR(a,b,c);
				}
			}
		break;
		case LONG_DOUBLE_PRECISION:
			if(	!strcmp(b->transform_kind_cp,DFT) ){
				fft_mull_CxC(a,b,c);
			}else{
				if(	!strcmp(a->transform_kind_cp,DFT) ){
					fft_mull_CxR(a,b,c);
				}else{
					fft_mull_RxR(a,b,c);
				}
			}
		break;	

	}
}//void fft_mul(Fftv* a,Fftv* b,Fftv* c)

	void fft_mulf_CxC(Fftv* a,Fftv* b,Fftv* c)
	{
//	  printf("||| fft_mulf_CxC \n");
	  float tmpReal_fl,tmpImage_fl;
	  for(int i=0; i<(a->fft_block_length_int) ;i++){
	    tmpReal_fl=((fftwf_complex*)b->out)[i][0];  //Real data
	    tmpImage_fl=((fftwf_complex*)b->out)[i][1];  //Image data
	    ((fftwf_complex*)c->out)[i][0]=tmpReal_fl*((fftwf_complex*)a->out)[i][0]-tmpImage_fl*((fftwf_complex*)a->out)[i][1];
	    ((fftwf_complex*)c->out)[i][1]=tmpReal_fl*((fftwf_complex*)a->out)[i][1]+tmpImage_fl*((fftwf_complex*)a->out)[i][0];

	//    ((fftwf_complex*)c->out)[i][0]=((fftwf_complex*)c->out)[i][0]/16;
	//    ((fftwf_complex*)c->out)[i][1]=((fftwf_complex*)c->out)[i][1]/16;
	  }
	}

	void fft_mul_CxC(Fftv* a,Fftv* b,Fftv* c)
	{
	  double tmpReal_dbl,tmpImage_dbl;
	  for(int i=0; i<(a->fft_block_length_int) ;i++){
	    tmpReal_dbl=((fftw_complex*)b->out)[i][0];  //Real data
	    tmpImage_dbl=((fftw_complex*)b->out)[i][1];  //Image data
	    ((fftw_complex*)c->out)[i][0]=tmpReal_dbl*((fftw_complex*)a->out)[i][0]-tmpImage_dbl*((fftw_complex*)a->out)[i][1];
	    ((fftw_complex*)c->out)[i][1]=tmpReal_dbl*((fftw_complex*)a->out)[i][1]+tmpImage_dbl*((fftw_complex*)a->out)[i][0];

	//    ((fftw_complex*)c->out)[i][0]=((fftw_complex*)c->out)[i][0]/16;
	//    ((fftw_complex*)c->out)[i][1]=((fftw_complex*)c->out)[i][1]/16;
	  }
	}
	
	void fft_mull_CxC(Fftv* a,Fftv* b,Fftv* c)
	{
	  long double tmpReal_ldbl,tmpImage_ldbl;
	  for(int i=0; i<(a->fft_block_length_int) ;i++){
	    tmpReal_ldbl=((fftwl_complex*)b->out)[i][0];  //Real data
	    tmpImage_ldbl=((fftwl_complex*)b->out)[i][1];  //Image data
	    ((fftwl_complex*)c->out)[i][0]=tmpReal_ldbl*((fftwl_complex*)a->out)[i][0]-tmpImage_ldbl*((fftwl_complex*)a->out)[i][1];
	    ((fftwl_complex*)c->out)[i][1]=tmpReal_ldbl*((fftwl_complex*)a->out)[i][1]+tmpImage_ldbl*((fftwl_complex*)a->out)[i][0];

	//    ((fftwl_complex*)c->out)[i][0]=((fftwl_complex*)c->out)[i][0]/16;
	//    ((fftwl_complex*)c->out)[i][1]=((fftwl_complex*)c->out)[i][1]/16;
	  }
	}
	
	
	void fft_mulf_RxR(Fftv* a,Fftv* b,Fftv* c)
	{
//		printf("||| fft_mulf_RxR \n");
	  float tmpReal_fl,tmpImage_fl;
	  ((float*)c->out)[                          0]=((float*)b->out)[                          0]*((float*)a->out)[                          0];
	  ((float*)c->out)[(a->fft_block_length_int)/2]=((float*)b->out)[(a->fft_block_length_int)/2]*((float*)a->out)[(a->fft_block_length_int)/2];
	
	//  for(int i=1;i<(length_int/2-1);i++){
	  for(int i=1;i<((a->fft_block_length_int)/2);i++){
	    tmpReal_fl =((float*)b->out)[                          i];  //Real data
	    tmpImage_fl=((float*)b->out)[(a->fft_block_length_int)-i];  //Image data
	
	    ((float*)c->out)[                          i]=tmpReal_fl*((float*)a->out)[                          i]-tmpImage_fl*((float*)a->out)[(a->fft_block_length_int)-i];//Real
	    ((float*)c->out)[(a->fft_block_length_int)-i]=tmpReal_fl*((float*)a->out)[(a->fft_block_length_int)-i]+tmpImage_fl*((float*)a->out)[                          i];//Image
	  }
	}
	
	void fft_mul_RxR(Fftv* a,Fftv* b,Fftv* c)
	{
	  double tmpReal_dbl,tmpImage_dbl;
	  ((double*)c->out)[                          0]=((double*)b->out)[                          0]*((double*)a->out)[                          0];
	  ((double*)c->out)[(a->fft_block_length_int)/2]=((double*)b->out)[(a->fft_block_length_int)/2]*((double*)a->out)[(a->fft_block_length_int)/2];
	
	//  for(int i=1;i<(length_int/2-1);i++){
	  for(int i=1;i<((a->fft_block_length_int)/2);i++){
	    tmpReal_dbl =((double*)b->out)[                          i];  //Real data
	    tmpImage_dbl=((double*)b->out)[(a->fft_block_length_int)-i];  //Image data
	
	    ((double*)c->out)[                          i]=tmpReal_dbl*((double*)a->out)[                          i]-tmpImage_dbl*((double*)a->out)[(a->fft_block_length_int)-i];//Real
	    ((double*)c->out)[(a->fft_block_length_int)-i]=tmpReal_dbl*((double*)a->out)[(a->fft_block_length_int)-i]+tmpImage_dbl*((double*)a->out)[                          i];//Image
	  }
	}
	
	void fft_mull_RxR(Fftv* a,Fftv* b,Fftv* c)
	{
	  long double tmpReal_ldbl,tmpImage_ldbl;
	  ((long double*)c->out)[                          0]=((long double*)b->out)[                          0]*((long double*)a->out)[                          0];
	  ((long double*)c->out)[(a->fft_block_length_int)/2]=((long double*)b->out)[(a->fft_block_length_int)/2]*((long double*)a->out)[(a->fft_block_length_int)/2];
	
	//  for(int i=1;i<(length_int/2-1);i++){
	  for(int i=1;i<((a->fft_block_length_int)/2);i++){
	    tmpReal_ldbl =((long double*)b->out)[                          i];  //Real data
	    tmpImage_ldbl=((long double*)b->out)[(a->fft_block_length_int)-i];  //Image data
	
	    ((long double*)c->out)[                          i]=tmpReal_ldbl*((long double*)a->out)[                          i]-tmpImage_ldbl*((long double*)a->out)[(a->fft_block_length_int)-i];//Real
	    ((long double*)c->out)[(a->fft_block_length_int)-i]=tmpReal_ldbl*((long double*)a->out)[(a->fft_block_length_int)-i]+tmpImage_ldbl*((long double*)a->out)[                          i];//Image
	  }
	}

	void fft_mulf_CxR(Fftv* a,Fftv* b,Fftv* c)
	{
//		printf("||| fft_mulf_CxR \n");
		float tmpReal_fl,tmpImage_fl;
		int i=0;
	  	tmpReal_fl =((float*)b->out)[                          0];
	  	tmpImage_fl=0;
	    ((fftwf_complex*)c->out)[i][0]=tmpReal_fl*((fftwf_complex*)a->out)[i][0]-tmpImage_fl*((fftwf_complex*)a->out)[i][1];
	    ((fftwf_complex*)c->out)[i][1]=tmpReal_fl*((fftwf_complex*)a->out)[i][1]+tmpImage_fl*((fftwf_complex*)a->out)[i][0];

	  	i=(a->fft_block_length_int)/2;
	  	tmpReal_fl =((float*)b->out)[(a->fft_block_length_int)/2];
	  	tmpImage_fl=0;
	    ((fftwf_complex*)c->out)[i][0]=tmpReal_fl*((fftwf_complex*)a->out)[i][0]-tmpImage_fl*((fftwf_complex*)a->out)[i][1];
	    ((fftwf_complex*)c->out)[i][1]=tmpReal_fl*((fftwf_complex*)a->out)[i][1]+tmpImage_fl*((fftwf_complex*)a->out)[i][0];
	
	  	for(i=1;i<((a->fft_block_length_int)/2);i++){
	    	tmpReal_fl =((float*)b->out)[                          i];  //Real data
	    	tmpImage_fl=((float*)b->out)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftwf_complex*)c->out)[i][0]=tmpReal_fl*((fftwf_complex*)a->out)[i][0]-tmpImage_fl*((fftwf_complex*)a->out)[i][1];
		    ((fftwf_complex*)c->out)[i][1]=tmpReal_fl*((fftwf_complex*)a->out)[i][1]+tmpImage_fl*((fftwf_complex*)a->out)[i][0];

		    ((fftwf_complex*)c->out)[(a->fft_block_length_int)-i][0]=tmpReal_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftwf_complex*)c->out)[(a->fft_block_length_int)-i][1]=tmpReal_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	}

	void fft_mul_CxR(Fftv* a,Fftv* b,Fftv* c)
	{
		double tmpReal_dbl,tmpImage_dbl;
		int i=0;
	  	tmpReal_dbl =((double*)b->out)[                          0];
	  	tmpImage_dbl=0;
	    ((fftw_complex*)c->out)[i][0]=tmpReal_dbl*((fftw_complex*)a->out)[i][0]-tmpImage_dbl*((fftw_complex*)a->out)[i][1];
	    ((fftw_complex*)c->out)[i][1]=tmpReal_dbl*((fftw_complex*)a->out)[i][1]+tmpImage_dbl*((fftw_complex*)a->out)[i][0];

	  	i=(a->fft_block_length_int)/2;
	  	tmpReal_dbl =((double*)b->out)[(a->fft_block_length_int)/2];
	  	tmpImage_dbl=0;
	    ((fftw_complex*)c->out)[i][0]=tmpReal_dbl*((fftw_complex*)a->out)[i][0]-tmpImage_dbl*((fftw_complex*)a->out)[i][1];
	    ((fftw_complex*)c->out)[i][1]=tmpReal_dbl*((fftw_complex*)a->out)[i][1]+tmpImage_dbl*((fftw_complex*)a->out)[i][0];
	
	  	for(i=1;i<((a->fft_block_length_int)/2);i++){
	    	tmpReal_dbl =((double*)b->out)[                          i];  //Real data
	    	tmpImage_dbl=((double*)b->out)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftw_complex*)c->out)[i][0]=tmpReal_dbl*((fftw_complex*)a->out)[i][0]-tmpImage_dbl*((fftw_complex*)a->out)[i][1];
		    ((fftw_complex*)c->out)[i][1]=tmpReal_dbl*((fftw_complex*)a->out)[i][1]+tmpImage_dbl*((fftw_complex*)a->out)[i][0];

		    ((fftw_complex*)c->out)[(a->fft_block_length_int)-i][0]=tmpReal_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftw_complex*)c->out)[(a->fft_block_length_int)-i][1]=tmpReal_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	}

	void fft_mull_CxR(Fftv* a,Fftv* b,Fftv* c)
	{
		long double tmpReal_ldbl,tmpImage_ldbl;
		int i=0;
	  	tmpReal_ldbl =((long double*)b->out)[                          0];
	  	tmpImage_ldbl=0;
	    ((fftwl_complex*)c->out)[i][0]=tmpReal_ldbl*((fftwl_complex*)a->out)[i][0]-tmpImage_ldbl*((fftwl_complex*)a->out)[i][1];
	    ((fftwl_complex*)c->out)[i][1]=tmpReal_ldbl*((fftwl_complex*)a->out)[i][1]+tmpImage_ldbl*((fftwl_complex*)a->out)[i][0];

	  	i=(a->fft_block_length_int)/2;
	  	tmpReal_ldbl =((long double*)b->out)[(a->fft_block_length_int)/2];
	  	tmpImage_ldbl=0;
	    ((fftwl_complex*)c->out)[i][0]=tmpReal_ldbl*((fftwl_complex*)a->out)[i][0]-tmpImage_ldbl*((fftwl_complex*)a->out)[i][1];
	    ((fftwl_complex*)c->out)[i][1]=tmpReal_ldbl*((fftwl_complex*)a->out)[i][1]+tmpImage_ldbl*((fftwl_complex*)a->out)[i][0];
	
	  	for(i=1;i<((a->fft_block_length_int)/2);i++){
	    	tmpReal_ldbl =((long double*)b->out)[                          i];  //Real data
	    	tmpImage_ldbl=((long double*)b->out)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftwl_complex*)c->out)[i][0]=tmpReal_ldbl*((fftwl_complex*)a->out)[i][0]-tmpImage_ldbl*((fftwl_complex*)a->out)[i][1];
		    ((fftwl_complex*)c->out)[i][1]=tmpReal_ldbl*((fftwl_complex*)a->out)[i][1]+tmpImage_ldbl*((fftwl_complex*)a->out)[i][0];

		    ((fftwl_complex*)c->out)[(a->fft_block_length_int)-i][0]=tmpReal_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftwl_complex*)c->out)[(a->fft_block_length_int)-i][1]=tmpReal_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	}

void fft_mul_Filter(Fftv* a,void* b,Fftv* c)
{
	switch(a->precision_int){
		case FLOAT_PRECISION:
			fft_mulf_CxFilter(a,b,c);
		break;
		case DOUBLE_PRECISION:
			fft_mul_CxFilter(a,b,c);
		break;
		case LONG_DOUBLE_PRECISION:
			fft_mull_CxFilter(a,b,c);
		break;	

	}
}

	void fft_mulf_CxFilter(Fftv* a,void* b,Fftv* c)
	{
//		printf("||| fft_mulf_CxR \n");
		float tmpReal_fl,tmpImage_fl;
		int i=0;
	  	tmpReal_fl =((float*)b)[                          0];
	  	tmpImage_fl=0;
	    ((fftwf_complex*)c->out)[i][0]=tmpReal_fl*((fftwf_complex*)a->out)[i][0]-tmpImage_fl*((fftwf_complex*)a->out)[i][1];
	    ((fftwf_complex*)c->out)[i][1]=tmpReal_fl*((fftwf_complex*)a->out)[i][1]+tmpImage_fl*((fftwf_complex*)a->out)[i][0];

	  	i=(a->fft_block_length_int)/2;
	  	tmpReal_fl =((float*)b)[(a->fft_block_length_int)/2];
	  	tmpImage_fl=0;
	    ((fftwf_complex*)c->out)[i][0]=tmpReal_fl*((fftwf_complex*)a->out)[i][0]-tmpImage_fl*((fftwf_complex*)a->out)[i][1];
	    ((fftwf_complex*)c->out)[i][1]=tmpReal_fl*((fftwf_complex*)a->out)[i][1]+tmpImage_fl*((fftwf_complex*)a->out)[i][0];
	
	  	for(i=1;i<((a->fft_block_length_int)/2);i++){
	    	tmpReal_fl =((float*)b)[                          i];  //Real data
	    	tmpImage_fl=((float*)b)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftwf_complex*)c->out)[i][0]=tmpReal_fl*((fftwf_complex*)a->out)[i][0]-tmpImage_fl*((fftwf_complex*)a->out)[i][1];
		    ((fftwf_complex*)c->out)[i][1]=tmpReal_fl*((fftwf_complex*)a->out)[i][1]+tmpImage_fl*((fftwf_complex*)a->out)[i][0];

		    ((fftwf_complex*)c->out)[(a->fft_block_length_int)-i][0]=tmpReal_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftwf_complex*)c->out)[(a->fft_block_length_int)-i][1]=tmpReal_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	}

	void fft_mul_CxFilter(Fftv* a,void* b,Fftv* c)
	{
		double tmpReal_dbl,tmpImage_dbl;
		int i=0;
	  	tmpReal_dbl =((double*)b)[                          0];
	  	tmpImage_dbl=0;
	    ((fftw_complex*)c->out)[i][0]=tmpReal_dbl*((fftw_complex*)a->out)[i][0]-tmpImage_dbl*((fftw_complex*)a->out)[i][1];
	    ((fftw_complex*)c->out)[i][1]=tmpReal_dbl*((fftw_complex*)a->out)[i][1]+tmpImage_dbl*((fftw_complex*)a->out)[i][0];

	  	i=(a->fft_block_length_int)/2;
	  	tmpReal_dbl =((double*)b)[(a->fft_block_length_int)/2];
	  	tmpImage_dbl=0;
	    ((fftw_complex*)c->out)[i][0]=tmpReal_dbl*((fftw_complex*)a->out)[i][0]-tmpImage_dbl*((fftw_complex*)a->out)[i][1];
	    ((fftw_complex*)c->out)[i][1]=tmpReal_dbl*((fftw_complex*)a->out)[i][1]+tmpImage_dbl*((fftw_complex*)a->out)[i][0];
	
	  	for(i=1;i<((a->fft_block_length_int)/2);i++){
	    	tmpReal_dbl =((double*)b)[                          i];  //Real data
	    	tmpImage_dbl=((double*)b)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftw_complex*)c->out)[i][0]=tmpReal_dbl*((fftw_complex*)a->out)[i][0]-tmpImage_dbl*((fftw_complex*)a->out)[i][1];
		    ((fftw_complex*)c->out)[i][1]=tmpReal_dbl*((fftw_complex*)a->out)[i][1]+tmpImage_dbl*((fftw_complex*)a->out)[i][0];

		    ((fftw_complex*)c->out)[(a->fft_block_length_int)-i][0]=tmpReal_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftw_complex*)c->out)[(a->fft_block_length_int)-i][1]=tmpReal_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	}

	void fft_mull_CxFilter(Fftv* a,void* b,Fftv* c)
	{
		long double tmpReal_ldbl,tmpImage_ldbl;
		int i=0;
	  	tmpReal_ldbl =((long double*)b)[                          0];
	  	tmpImage_ldbl=0;
	    ((fftwl_complex*)c->out)[i][0]=tmpReal_ldbl*((fftwl_complex*)a->out)[i][0]-tmpImage_ldbl*((fftwl_complex*)a->out)[i][1];
	    ((fftwl_complex*)c->out)[i][1]=tmpReal_ldbl*((fftwl_complex*)a->out)[i][1]+tmpImage_ldbl*((fftwl_complex*)a->out)[i][0];

	  	i=(a->fft_block_length_int)/2;
	  	tmpReal_ldbl =((long double*)b)[(a->fft_block_length_int)/2];
	  	tmpImage_ldbl=0;
	    ((fftwl_complex*)c->out)[i][0]=tmpReal_ldbl*((fftwl_complex*)a->out)[i][0]-tmpImage_ldbl*((fftwl_complex*)a->out)[i][1];
	    ((fftwl_complex*)c->out)[i][1]=tmpReal_ldbl*((fftwl_complex*)a->out)[i][1]+tmpImage_ldbl*((fftwl_complex*)a->out)[i][0];
	
	  	for(i=1;i<((a->fft_block_length_int)/2);i++){
	    	tmpReal_ldbl =((long double*)b)[                          i];  //Real data
	    	tmpImage_ldbl=((long double*)b)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftwl_complex*)c->out)[i][0]=tmpReal_ldbl*((fftwl_complex*)a->out)[i][0]-tmpImage_ldbl*((fftwl_complex*)a->out)[i][1];
		    ((fftwl_complex*)c->out)[i][1]=tmpReal_ldbl*((fftwl_complex*)a->out)[i][1]+tmpImage_ldbl*((fftwl_complex*)a->out)[i][0];

		    ((fftwl_complex*)c->out)[(a->fft_block_length_int)-i][0]=tmpReal_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftwl_complex*)c->out)[(a->fft_block_length_int)-i][1]=tmpReal_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	}

void fft_mul_add_Filter(Fftv* a,void* b,Fftv* c)
{
	switch(a->precision_int){
		case FLOAT_PRECISION:
			fft_mulf_add_CxFilter(a,b,c);
		break;
		case DOUBLE_PRECISION:
			fft_mul_add_CxFilter(a,b,c);
		break;
		case LONG_DOUBLE_PRECISION:
			fft_mull_add_CxFilter(a,b,c);
		break;	

	}
}

	void fft_mulf_add_CxFilter(Fftv* a,void* b,Fftv* c)
	{
//		printf("||| fft_mulf_CxR \n");
		float tmpReal_fl,tmpImage_fl;
		int i=0;
	  	tmpReal_fl =((float*)b)[                          0];
	  	tmpImage_fl=0;
	    ((fftwf_complex*)c->out)[i][0]+=tmpReal_fl*((fftwf_complex*)a->out)[i][0]-tmpImage_fl*((fftwf_complex*)a->out)[i][1];
	    ((fftwf_complex*)c->out)[i][1]+=tmpReal_fl*((fftwf_complex*)a->out)[i][1]+tmpImage_fl*((fftwf_complex*)a->out)[i][0];

	  	i=(a->fft_block_length_int)/2;
	  	tmpReal_fl =((float*)b)[(a->fft_block_length_int)/2];
	  	tmpImage_fl=0;
	    ((fftwf_complex*)c->out)[i][0]+=tmpReal_fl*((fftwf_complex*)a->out)[i][0]-tmpImage_fl*((fftwf_complex*)a->out)[i][1];
	    ((fftwf_complex*)c->out)[i][1]+=tmpReal_fl*((fftwf_complex*)a->out)[i][1]+tmpImage_fl*((fftwf_complex*)a->out)[i][0];
	
	  	for(i=1;i<((a->fft_block_length_int)/2);i++){
	    	tmpReal_fl =((float*)b)[                          i];  //Real data
	    	tmpImage_fl=((float*)b)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftwf_complex*)c->out)[i][0]+=tmpReal_fl*((fftwf_complex*)a->out)[i][0]-tmpImage_fl*((fftwf_complex*)a->out)[i][1];
		    ((fftwf_complex*)c->out)[i][1]+=tmpReal_fl*((fftwf_complex*)a->out)[i][1]+tmpImage_fl*((fftwf_complex*)a->out)[i][0];

		    ((fftwf_complex*)c->out)[(a->fft_block_length_int)-i][0]+=tmpReal_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftwf_complex*)c->out)[(a->fft_block_length_int)-i][1]+=tmpReal_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	}

	void fft_mul_add_CxFilter(Fftv* a,void* b,Fftv* c)
	{
		double tmpReal_dbl,tmpImage_dbl;
		int i=0;
	  	tmpReal_dbl =((double*)b)[                          0];
	  	tmpImage_dbl=0;
	    ((fftw_complex*)c->out)[i][0]+=tmpReal_dbl*((fftw_complex*)a->out)[i][0]-tmpImage_dbl*((fftw_complex*)a->out)[i][1];
	    ((fftw_complex*)c->out)[i][1]+=tmpReal_dbl*((fftw_complex*)a->out)[i][1]+tmpImage_dbl*((fftw_complex*)a->out)[i][0];

	  	i=(a->fft_block_length_int)/2;
	  	tmpReal_dbl =((double*)b)[(a->fft_block_length_int)/2];
	  	tmpImage_dbl=0;
	    ((fftw_complex*)c->out)[i][0]+=tmpReal_dbl*((fftw_complex*)a->out)[i][0]-tmpImage_dbl*((fftw_complex*)a->out)[i][1];
	    ((fftw_complex*)c->out)[i][1]+=tmpReal_dbl*((fftw_complex*)a->out)[i][1]+tmpImage_dbl*((fftw_complex*)a->out)[i][0];
	
	  	for(i=1;i<((a->fft_block_length_int)/2);i++){
	    	tmpReal_dbl =((double*)b)[                          i];  //Real data
	    	tmpImage_dbl=((double*)b)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftw_complex*)c->out)[i][0]+=tmpReal_dbl*((fftw_complex*)a->out)[i][0]-tmpImage_dbl*((fftw_complex*)a->out)[i][1];
		    ((fftw_complex*)c->out)[i][1]+=tmpReal_dbl*((fftw_complex*)a->out)[i][1]+tmpImage_dbl*((fftw_complex*)a->out)[i][0];

		    ((fftw_complex*)c->out)[(a->fft_block_length_int)-i][0]+=tmpReal_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftw_complex*)c->out)[(a->fft_block_length_int)-i][1]+=tmpReal_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	}

	void fft_mull_add_CxFilter(Fftv* a,void* b,Fftv* c)
	{
		long double tmpReal_ldbl,tmpImage_ldbl;
		int i=0;
	  	tmpReal_ldbl =((long double*)b)[                          0];
	  	tmpImage_ldbl=0;
	    ((fftwl_complex*)c->out)[i][0]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][0]-tmpImage_ldbl*((fftwl_complex*)a->out)[i][1];
	    ((fftwl_complex*)c->out)[i][1]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][1]+tmpImage_ldbl*((fftwl_complex*)a->out)[i][0];

	  	i=(a->fft_block_length_int)/2;
	  	tmpReal_ldbl =((long double*)b)[(a->fft_block_length_int)/2];
	  	tmpImage_ldbl=0;
	    ((fftwl_complex*)c->out)[i][0]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][0]-tmpImage_ldbl*((fftwl_complex*)a->out)[i][1];
	    ((fftwl_complex*)c->out)[i][1]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][1]+tmpImage_ldbl*((fftwl_complex*)a->out)[i][0];
	
	  	for(i=1;i<((a->fft_block_length_int)/2);i++){
	    	tmpReal_ldbl =((long double*)b)[                          i];  //Real data
	    	tmpImage_ldbl=((long double*)b)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftwl_complex*)c->out)[i][0]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][0]-tmpImage_ldbl*((fftwl_complex*)a->out)[i][1];
		    ((fftwl_complex*)c->out)[i][1]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][1]+tmpImage_ldbl*((fftwl_complex*)a->out)[i][0];

		    ((fftwl_complex*)c->out)[(a->fft_block_length_int)-i][0]+=tmpReal_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftwl_complex*)c->out)[(a->fft_block_length_int)-i][1]+=tmpReal_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	}

//********************************************************************

//calculate before center tap
//c.in += a.out * rev(b.out)
void fft_rev_mul_add(Fftv* a,Fftv* b,Fftv* c) 
{
	switch(a->precision_int){
		case FLOAT_PRECISION:
			if(	!strcmp(b->transform_kind_cp,DFT) ){
				fft_rev_mulf_add_CxC(a,b,c);
			}else{
				if(	!strcmp(a->transform_kind_cp,DFT) ){
					fft_rev_mulf_add_CxR(a,b,c);
				}else{
					fft_rev_mulf_add_RxR(a,b,c);
				}
			}
		break;
		case DOUBLE_PRECISION:
			if(	!strcmp(b->transform_kind_cp,DFT) ){
				fft_rev_mul_add_CxC(a,b,c);
			}else{
				if(	!strcmp(a->transform_kind_cp,DFT) ){
					fft_rev_mul_add_CxR(a,b,c);
				}else{
					fft_rev_mul_add_RxR(a,b,c);
				}
			}
		break;
		case LONG_DOUBLE_PRECISION:
			if(	!strcmp(b->transform_kind_cp,DFT) ){
				fft_rev_mull_add_CxC(a,b,c);
			}else{
				if(	!strcmp(a->transform_kind_cp,DFT) ){
					fft_rev_mull_add_CxR(a,b,c);
				}else{
					fft_rev_mull_add_RxR(a,b,c);
				}
			}
		break;	

	}
}//void fft_mul(Fftv* a,Fftv* b,Fftv* c)


	void fft_rev_mulf_add_CxC(Fftv* a,Fftv* b,Fftv* c)
	{
	  float tmpReal_fl,tmpImage_fl;
	  for(int i=0; i<(a->fft_block_length_int) ;i++){
	    tmpReal_fl =  ((fftwf_complex*)b->out)[i][0];  //Real data
	    tmpImage_fl= -((fftwf_complex*)b->out)[i][1];  //Image data
	    ((fftwf_complex*)c->out)[i][0]+=tmpReal_fl*((fftwf_complex*)a->out)[i][0]-tmpImage_fl*((fftwf_complex*)a->out)[i][1];
	    ((fftwf_complex*)c->out)[i][1]+=tmpReal_fl*((fftwf_complex*)a->out)[i][1]+tmpImage_fl*((fftwf_complex*)a->out)[i][0];

		i++;
		
	    tmpReal_fl = -((fftwf_complex*)b->out)[i][0];  //Real data
	    tmpImage_fl=  ((fftwf_complex*)b->out)[i][1];  //Image data
	    ((fftwf_complex*)c->out)[i][0]+=tmpReal_fl*((fftwf_complex*)a->out)[i][0]-tmpImage_fl*((fftwf_complex*)a->out)[i][1];
	    ((fftwf_complex*)c->out)[i][1]+=tmpReal_fl*((fftwf_complex*)a->out)[i][1]+tmpImage_fl*((fftwf_complex*)a->out)[i][0];
	  }
	}

	void fft_rev_mul_add_CxC(Fftv* a,Fftv* b,Fftv* c)
	{
	  double tmpReal_dbl,tmpImage_dbl;
	  for(int i=0; i<(a->fft_block_length_int) ;i++){
	    tmpReal_dbl =  ((fftw_complex*)b->out)[i][0];  //Real data
	    tmpImage_dbl= -((fftw_complex*)b->out)[i][1];  //Image data
	    ((fftw_complex*)c->out)[i][0]+=tmpReal_dbl*((fftw_complex*)a->out)[i][0]-tmpImage_dbl*((fftw_complex*)a->out)[i][1];
	    ((fftw_complex*)c->out)[i][1]+=tmpReal_dbl*((fftw_complex*)a->out)[i][1]+tmpImage_dbl*((fftw_complex*)a->out)[i][0];

		i++;

	    tmpReal_dbl = -((fftw_complex*)b->out)[i][0];  //Real data
	    tmpImage_dbl=  ((fftw_complex*)b->out)[i][1];  //Image data
	    ((fftw_complex*)c->out)[i][0]+=tmpReal_dbl*((fftw_complex*)a->out)[i][0]-tmpImage_dbl*((fftw_complex*)a->out)[i][1];
	    ((fftw_complex*)c->out)[i][1]+=tmpReal_dbl*((fftw_complex*)a->out)[i][1]+tmpImage_dbl*((fftw_complex*)a->out)[i][0];
	  }
	}
	
	void fft_rev_mull_add_CxC(Fftv* a,Fftv* b,Fftv* c)
	{
	  long double tmpReal_ldbl,tmpImage_ldbl;
	  for(int i=0; i<(a->fft_block_length_int) ;i++){
	    tmpReal_ldbl =  ((fftwl_complex*)b->out)[i][0];  //Real data
	    tmpImage_ldbl= -((fftwl_complex*)b->out)[i][1];  //Image data
	    ((fftwl_complex*)c->out)[i][0]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][0]-tmpImage_ldbl*((fftwl_complex*)a->out)[i][1];
	    ((fftwl_complex*)c->out)[i][1]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][1]+tmpImage_ldbl*((fftwl_complex*)a->out)[i][0];

		i++;

	    tmpReal_ldbl = -((fftwl_complex*)b->out)[i][0];  //Real data
	    tmpImage_ldbl=  ((fftwl_complex*)b->out)[i][1];  //Image data
	    ((fftwl_complex*)c->out)[i][0]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][0]-tmpImage_ldbl*((fftwl_complex*)a->out)[i][1];
	    ((fftwl_complex*)c->out)[i][1]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][1]+tmpImage_ldbl*((fftwl_complex*)a->out)[i][0];
	  }
	}
	
	
	void fft_rev_mulf_add_RxR(Fftv* a,Fftv* b,Fftv* c)
	{
	  float tmpReal_fl,tmpImage_fl;
	  ((float*)c->out)[                          0]+=((float*)b->out)[                          0]*((float*)a->out)[                          0];
	  ((float*)c->out)[(a->fft_block_length_int)/2]+=((float*)b->out)[(a->fft_block_length_int)/2]*((float*)a->out)[(a->fft_block_length_int)/2];
	
	//  for(int i=1;i<(length_int/2-1);i++){
	  for(int i=1;i<((a->fft_block_length_int)/2);i+=2){
	    tmpReal_fl = -((float*)b->out)[                          i];  //Real data
	    tmpImage_fl=  ((float*)b->out)[(a->fft_block_length_int)-i];  //Image data
	
	    ((float*)c->out)[                          i]+=tmpReal_fl*((float*)a->out)[                          i]-tmpImage_fl*((float*)a->out)[(a->fft_block_length_int)-i];//Real
	    ((float*)c->out)[(a->fft_block_length_int)-i]+=tmpReal_fl*((float*)a->out)[(a->fft_block_length_int)-i]+tmpImage_fl*((float*)a->out)[                          i];//Image
	  }
	  for(int i=2;i<((a->fft_block_length_int)/2);i+=2){
	    tmpReal_fl =  ((float*)b->out)[                          i];  //Real data
	    tmpImage_fl= -((float*)b->out)[(a->fft_block_length_int)-i];  //Image data
	
	    ((float*)c->out)[                          i]+=tmpReal_fl*((float*)a->out)[                          i]-tmpImage_fl*((float*)a->out)[(a->fft_block_length_int)-i];//Real
	    ((float*)c->out)[(a->fft_block_length_int)-i]+=tmpReal_fl*((float*)a->out)[(a->fft_block_length_int)-i]+tmpImage_fl*((float*)a->out)[                          i];//Image
	  }

	}
	
	void fft_rev_mul_add_RxR(Fftv* a,Fftv* b,Fftv* c)
	{
	  double tmpReal_dbl,tmpImage_dbl;
	  ((double*)c->out)[                          0]+=((double*)b->out)[                          0]*((double*)a->out)[                          0];
	  ((double*)c->out)[(a->fft_block_length_int)/2]+=((double*)b->out)[(a->fft_block_length_int)/2]*((double*)a->out)[(a->fft_block_length_int)/2];
	
	//  for(int i=1;i<(length_int/2-1);i++){
	  for(int i=1;i<((a->fft_block_length_int)/2);i+=2){
	    tmpReal_dbl = -((double*)b->out)[                          i];  //Real data
	    tmpImage_dbl=  ((double*)b->out)[(a->fft_block_length_int)-i];  //Image data
	
	    ((double*)c->out)[                          i]+=tmpReal_dbl*((double*)a->out)[                          i]-tmpImage_dbl*((double*)a->out)[(a->fft_block_length_int)-i];//Real
	    ((double*)c->out)[(a->fft_block_length_int)-i]+=tmpReal_dbl*((double*)a->out)[(a->fft_block_length_int)-i]+tmpImage_dbl*((double*)a->out)[                          i];//Image
	  }
	  for(int i=2;i<((a->fft_block_length_int)/2);i+=2){
	    tmpReal_dbl =  ((double*)b->out)[                          i];  //Real data
	    tmpImage_dbl= -((double*)b->out)[(a->fft_block_length_int)-i];  //Image data
	
	    ((double*)c->out)[                          i]+=tmpReal_dbl*((double*)a->out)[                          i]-tmpImage_dbl*((double*)a->out)[(a->fft_block_length_int)-i];//Real
	    ((double*)c->out)[(a->fft_block_length_int)-i]+=tmpReal_dbl*((double*)a->out)[(a->fft_block_length_int)-i]+tmpImage_dbl*((double*)a->out)[                          i];//Image
	  }
	}
	
	void fft_rev_mull_add_RxR(Fftv* a,Fftv* b,Fftv* c)
	{
	  long double tmpReal_ldbl,tmpImage_ldbl;
	  ((long double*)c->out)[                          0]+=((long double*)b->out)[                          0]*((long double*)a->out)[                          0];
	  ((long double*)c->out)[(a->fft_block_length_int)/2]+=((long double*)b->out)[(a->fft_block_length_int)/2]*((long double*)a->out)[(a->fft_block_length_int)/2];
	
	//  for(int i=1;i<(length_int/2-1);i++){
	  for(int i=1;i<((a->fft_block_length_int)/2);i+=2){
	    tmpReal_ldbl = -((long double*)b->out)[                          i];  //Real data
	    tmpImage_ldbl=  ((long double*)b->out)[(a->fft_block_length_int)-i];  //Image data
	
	    ((long double*)c->out)[                          i]+=tmpReal_ldbl*((long double*)a->out)[                          i]-tmpImage_ldbl*((long double*)a->out)[(a->fft_block_length_int)-i];//Real
	    ((long double*)c->out)[(a->fft_block_length_int)-i]+=tmpReal_ldbl*((long double*)a->out)[(a->fft_block_length_int)-i]+tmpImage_ldbl*((long double*)a->out)[                          i];//Image
	  }
	  for(int i=2;i<((a->fft_block_length_int)/2);i+=2){
	    tmpReal_ldbl =  ((long double*)b->out)[                          i];  //Real data
	    tmpImage_ldbl= -((long double*)b->out)[(a->fft_block_length_int)-i];  //Image data
	
	    ((long double*)c->out)[                          i]+=tmpReal_ldbl*((long double*)a->out)[                          i]-tmpImage_ldbl*((long double*)a->out)[(a->fft_block_length_int)-i];//Real
	    ((long double*)c->out)[(a->fft_block_length_int)-i]+=tmpReal_ldbl*((long double*)a->out)[(a->fft_block_length_int)-i]+tmpImage_ldbl*((long double*)a->out)[                          i];//Image
	  }
	}

	void fft_rev_mulf_add_CxR(Fftv* a,Fftv* b,Fftv* c)
	{
//		printf("||| fft_rev_mulf_add_CxR \n");
		
		float tmpReal_fl,tmpImage_fl;
		int i=0;
	  	tmpReal_fl =((float*)b->out)[                          0];
	  	tmpImage_fl=0;
	    ((fftwf_complex*)c->out)[i][0]+=tmpReal_fl*((fftwf_complex*)a->out)[i][0]-tmpImage_fl*((fftwf_complex*)a->out)[i][1];
	    ((fftwf_complex*)c->out)[i][1]+=tmpReal_fl*((fftwf_complex*)a->out)[i][1]+tmpImage_fl*((fftwf_complex*)a->out)[i][0];

	  	i=(a->fft_block_length_int)/2;
	  	tmpReal_fl =((float*)b->out)[(a->fft_block_length_int)/2];
	  	tmpImage_fl=0;
	    ((fftwf_complex*)c->out)[i][0]+=tmpReal_fl*((fftwf_complex*)a->out)[i][0]-tmpImage_fl*((fftwf_complex*)a->out)[i][1];
	    ((fftwf_complex*)c->out)[i][1]+=tmpReal_fl*((fftwf_complex*)a->out)[i][1]+tmpImage_fl*((fftwf_complex*)a->out)[i][0];
	
	  	for(i=1;i<((a->fft_block_length_int)/2);i+=2){
	    	tmpReal_fl = -((float*)b->out)[                          i];  //Real data
	    	tmpImage_fl=  ((float*)b->out)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftwf_complex*)c->out)[i][0]+=tmpReal_fl*((fftwf_complex*)a->out)[i][0]-tmpImage_fl*((fftwf_complex*)a->out)[i][1];
		    ((fftwf_complex*)c->out)[i][1]+=tmpReal_fl*((fftwf_complex*)a->out)[i][1]+tmpImage_fl*((fftwf_complex*)a->out)[i][0];

		    ((fftwf_complex*)c->out)[(a->fft_block_length_int)-i][0]+=tmpReal_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftwf_complex*)c->out)[(a->fft_block_length_int)-i][1]+=tmpReal_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	  	for(i=2;i<((a->fft_block_length_int)/2);i+=2){
	    	tmpReal_fl =  ((float*)b->out)[                          i];  //Real data
	    	tmpImage_fl= -((float*)b->out)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftwf_complex*)c->out)[i][0]+=tmpReal_fl*((fftwf_complex*)a->out)[i][0]-tmpImage_fl*((fftwf_complex*)a->out)[i][1];
		    ((fftwf_complex*)c->out)[i][1]+=tmpReal_fl*((fftwf_complex*)a->out)[i][1]+tmpImage_fl*((fftwf_complex*)a->out)[i][0];

		    ((fftwf_complex*)c->out)[(a->fft_block_length_int)-i][0]+=tmpReal_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftwf_complex*)c->out)[(a->fft_block_length_int)-i][1]+=tmpReal_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	}

	void fft_rev_mul_add_CxR(Fftv* a,Fftv* b,Fftv* c)
	{
		double tmpReal_dbl,tmpImage_dbl;
		int i=0;
	  	tmpReal_dbl =((double*)b->out)[                          0];
	  	tmpImage_dbl=0;
	    ((fftw_complex*)c->out)[i][0]+=tmpReal_dbl*((fftw_complex*)a->out)[i][0]-tmpImage_dbl*((fftw_complex*)a->out)[i][1];
	    ((fftw_complex*)c->out)[i][1]+=tmpReal_dbl*((fftw_complex*)a->out)[i][1]+tmpImage_dbl*((fftw_complex*)a->out)[i][0];

	  	i=(a->fft_block_length_int)/2;
	  	tmpReal_dbl =((double*)b->out)[(a->fft_block_length_int)/2];
	  	tmpImage_dbl=0;
	    ((fftw_complex*)c->out)[i][0]+=tmpReal_dbl*((fftw_complex*)a->out)[i][0]-tmpImage_dbl*((fftw_complex*)a->out)[i][1];
	    ((fftw_complex*)c->out)[i][1]+=tmpReal_dbl*((fftw_complex*)a->out)[i][1]+tmpImage_dbl*((fftw_complex*)a->out)[i][0];
	
	  	for(i=1;i<((a->fft_block_length_int)/2);i+=2){
	    	tmpReal_dbl = -((double*)b->out)[                          i];  //Real data
	    	tmpImage_dbl=  ((double*)b->out)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftw_complex*)c->out)[i][0]+=tmpReal_dbl*((fftw_complex*)a->out)[i][0]-tmpImage_dbl*((fftw_complex*)a->out)[i][1];
		    ((fftw_complex*)c->out)[i][1]+=tmpReal_dbl*((fftw_complex*)a->out)[i][1]+tmpImage_dbl*((fftw_complex*)a->out)[i][0];

		    ((fftw_complex*)c->out)[(a->fft_block_length_int)-i][0]+=tmpReal_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftw_complex*)c->out)[(a->fft_block_length_int)-i][1]+=tmpReal_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	  	for(i=2;i<((a->fft_block_length_int)/2);i+=2){
	    	tmpReal_dbl =  ((double*)b->out)[                          i];  //Real data
	    	tmpImage_dbl= -((double*)b->out)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftw_complex*)c->out)[i][0]+=tmpReal_dbl*((fftw_complex*)a->out)[i][0]-tmpImage_dbl*((fftw_complex*)a->out)[i][1];
		    ((fftw_complex*)c->out)[i][1]+=tmpReal_dbl*((fftw_complex*)a->out)[i][1]+tmpImage_dbl*((fftw_complex*)a->out)[i][0];

		    ((fftw_complex*)c->out)[(a->fft_block_length_int)-i][0]+=tmpReal_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftw_complex*)c->out)[(a->fft_block_length_int)-i][1]+=tmpReal_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	}
	
	void fft_rev_mull_add_CxR(Fftv* a,Fftv* b,Fftv* c)
	{
		long double tmpReal_ldbl,tmpImage_ldbl;
		int i=0;
	  	tmpReal_ldbl =((long double*)b->out)[                          0];
	  	tmpImage_ldbl=0;
	    ((fftwl_complex*)c->out)[i][0]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][0]-tmpImage_ldbl*((fftwl_complex*)a->out)[i][1];
	    ((fftwl_complex*)c->out)[i][1]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][1]+tmpImage_ldbl*((fftwl_complex*)a->out)[i][0];

	  	i=(a->fft_block_length_int)/2;
	  	tmpReal_ldbl =((long double*)b->out)[(a->fft_block_length_int)/2];
	  	tmpImage_ldbl=0;
	    ((fftwl_complex*)c->out)[i][0]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][0]-tmpImage_ldbl*((fftwl_complex*)a->out)[i][1];
	    ((fftwl_complex*)c->out)[i][1]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][1]+tmpImage_ldbl*((fftwl_complex*)a->out)[i][0];
	
	  	for(i=1;i<((a->fft_block_length_int)/2);i+=2){
	    	tmpReal_ldbl = -((long double*)b->out)[                          i];  //Real data
	    	tmpImage_ldbl=  ((long double*)b->out)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftwl_complex*)c->out)[i][0]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][0]-tmpImage_ldbl*((fftwl_complex*)a->out)[i][1];
		    ((fftwl_complex*)c->out)[i][1]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][1]+tmpImage_ldbl*((fftwl_complex*)a->out)[i][0];

		    ((fftwl_complex*)c->out)[(a->fft_block_length_int)-i][0]+=tmpReal_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftwl_complex*)c->out)[(a->fft_block_length_int)-i][1]+=tmpReal_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	  	for(i=2;i<((a->fft_block_length_int)/2);i+=2){
	    	tmpReal_ldbl =  ((long double*)b->out)[                          i];  //Real data
	    	tmpImage_ldbl= -((long double*)b->out)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftwl_complex*)c->out)[i][0]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][0]-tmpImage_ldbl*((fftwl_complex*)a->out)[i][1];
		    ((fftwl_complex*)c->out)[i][1]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][1]+tmpImage_ldbl*((fftwl_complex*)a->out)[i][0];

		    ((fftwl_complex*)c->out)[(a->fft_block_length_int)-i][0]+=tmpReal_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftwl_complex*)c->out)[(a->fft_block_length_int)-i][1]+=tmpReal_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	}


//calculate before center tap
//c.in += a.out * rev(b)
void fft_rev_mul_add_Filter(Fftv* a,void* b,Fftv* c) 
{
	switch(a->precision_int){
		case FLOAT_PRECISION:
			fft_rev_mulf_add_CxFilter(a,b,c);
		break;
		case DOUBLE_PRECISION:
			fft_rev_mul_add_CxFilter(a,b,c);
		break;
		case LONG_DOUBLE_PRECISION:
			fft_rev_mull_add_CxFilter(a,b,c);
		break;	

	}
}

	void fft_rev_mulf_add_CxFilter(Fftv* a,void* b,Fftv* c)
	{
//		printf("||| fft_rev_mulf_add_CxR \n");
		
		float tmpReal_fl,tmpImage_fl;
		int i=0;
	  	tmpReal_fl =((float*)b)[                          0];
	  	tmpImage_fl=0;
	    ((fftwf_complex*)c->out)[i][0]+=tmpReal_fl*((fftwf_complex*)a->out)[i][0]-tmpImage_fl*((fftwf_complex*)a->out)[i][1];
	    ((fftwf_complex*)c->out)[i][1]+=tmpReal_fl*((fftwf_complex*)a->out)[i][1]+tmpImage_fl*((fftwf_complex*)a->out)[i][0];

	  	i=(a->fft_block_length_int)/2;
	  	tmpReal_fl =((float*)b)[(a->fft_block_length_int)/2];
	  	tmpImage_fl=0;
	    ((fftwf_complex*)c->out)[i][0]+=tmpReal_fl*((fftwf_complex*)a->out)[i][0]-tmpImage_fl*((fftwf_complex*)a->out)[i][1];
	    ((fftwf_complex*)c->out)[i][1]+=tmpReal_fl*((fftwf_complex*)a->out)[i][1]+tmpImage_fl*((fftwf_complex*)a->out)[i][0];
	
	  	for(i=1;i<((a->fft_block_length_int)/2);i+=2){
	    	tmpReal_fl = -((float*)b)[                          i];  //Real data
	    	tmpImage_fl=  ((float*)b)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftwf_complex*)c->out)[i][0]+=tmpReal_fl*((fftwf_complex*)a->out)[i][0]-tmpImage_fl*((fftwf_complex*)a->out)[i][1];
		    ((fftwf_complex*)c->out)[i][1]+=tmpReal_fl*((fftwf_complex*)a->out)[i][1]+tmpImage_fl*((fftwf_complex*)a->out)[i][0];

		    ((fftwf_complex*)c->out)[(a->fft_block_length_int)-i][0]+=tmpReal_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftwf_complex*)c->out)[(a->fft_block_length_int)-i][1]+=tmpReal_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	  	for(i=2;i<((a->fft_block_length_int)/2);i+=2){
	    	tmpReal_fl =  ((float*)b)[                          i];  //Real data
	    	tmpImage_fl= -((float*)b)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftwf_complex*)c->out)[i][0]+=tmpReal_fl*((fftwf_complex*)a->out)[i][0]-tmpImage_fl*((fftwf_complex*)a->out)[i][1];
		    ((fftwf_complex*)c->out)[i][1]+=tmpReal_fl*((fftwf_complex*)a->out)[i][1]+tmpImage_fl*((fftwf_complex*)a->out)[i][0];

		    ((fftwf_complex*)c->out)[(a->fft_block_length_int)-i][0]+=tmpReal_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftwf_complex*)c->out)[(a->fft_block_length_int)-i][1]+=tmpReal_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	}

	void fft_rev_mul_add_CxFilter(Fftv* a,void* b,Fftv* c)
	{
		double tmpReal_dbl,tmpImage_dbl;
		int i=0;
	  	tmpReal_dbl =((double*)b)[                          0];
	  	tmpImage_dbl=0;
	    ((fftw_complex*)c->out)[i][0]+=tmpReal_dbl*((fftw_complex*)a->out)[i][0]-tmpImage_dbl*((fftw_complex*)a->out)[i][1];
	    ((fftw_complex*)c->out)[i][1]+=tmpReal_dbl*((fftw_complex*)a->out)[i][1]+tmpImage_dbl*((fftw_complex*)a->out)[i][0];

	  	i=(a->fft_block_length_int)/2;
	  	tmpReal_dbl =((double*)b)[(a->fft_block_length_int)/2];
	  	tmpImage_dbl=0;
	    ((fftw_complex*)c->out)[i][0]+=tmpReal_dbl*((fftw_complex*)a->out)[i][0]-tmpImage_dbl*((fftw_complex*)a->out)[i][1];
	    ((fftw_complex*)c->out)[i][1]+=tmpReal_dbl*((fftw_complex*)a->out)[i][1]+tmpImage_dbl*((fftw_complex*)a->out)[i][0];
	
	  	for(i=1;i<((a->fft_block_length_int)/2);i+=2){
	    	tmpReal_dbl = -((double*)b)[                          i];  //Real data
	    	tmpImage_dbl=  ((double*)b)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftw_complex*)c->out)[i][0]+=tmpReal_dbl*((fftw_complex*)a->out)[i][0]-tmpImage_dbl*((fftw_complex*)a->out)[i][1];
		    ((fftw_complex*)c->out)[i][1]+=tmpReal_dbl*((fftw_complex*)a->out)[i][1]+tmpImage_dbl*((fftw_complex*)a->out)[i][0];

		    ((fftw_complex*)c->out)[(a->fft_block_length_int)-i][0]+=tmpReal_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftw_complex*)c->out)[(a->fft_block_length_int)-i][1]+=tmpReal_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	  	for(i=2;i<((a->fft_block_length_int)/2);i+=2){
	    	tmpReal_dbl =  ((double*)b)[                          i];  //Real data
	    	tmpImage_dbl= -((double*)b)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftw_complex*)c->out)[i][0]+=tmpReal_dbl*((fftw_complex*)a->out)[i][0]-tmpImage_dbl*((fftw_complex*)a->out)[i][1];
		    ((fftw_complex*)c->out)[i][1]+=tmpReal_dbl*((fftw_complex*)a->out)[i][1]+tmpImage_dbl*((fftw_complex*)a->out)[i][0];

		    ((fftw_complex*)c->out)[(a->fft_block_length_int)-i][0]+=tmpReal_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftw_complex*)c->out)[(a->fft_block_length_int)-i][1]+=tmpReal_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	}
	
	void fft_rev_mull_add_CxFilter(Fftv* a,void* b,Fftv* c)
	{
		long double tmpReal_ldbl,tmpImage_ldbl;
		int i=0;
	  	tmpReal_ldbl =((long double*)b)[                          0];
	  	tmpImage_ldbl=0;
	    ((fftwl_complex*)c->out)[i][0]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][0]-tmpImage_ldbl*((fftwl_complex*)a->out)[i][1];
	    ((fftwl_complex*)c->out)[i][1]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][1]+tmpImage_ldbl*((fftwl_complex*)a->out)[i][0];

	  	i=(a->fft_block_length_int)/2;
	  	tmpReal_ldbl =((long double*)b)[(a->fft_block_length_int)/2];
	  	tmpImage_ldbl=0;
	    ((fftwl_complex*)c->out)[i][0]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][0]-tmpImage_ldbl*((fftwl_complex*)a->out)[i][1];
	    ((fftwl_complex*)c->out)[i][1]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][1]+tmpImage_ldbl*((fftwl_complex*)a->out)[i][0];
	
	  	for(i=1;i<((a->fft_block_length_int)/2);i+=2){
	    	tmpReal_ldbl = -((long double*)b)[                          i];  //Real data
	    	tmpImage_ldbl=  ((long double*)b)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftwl_complex*)c->out)[i][0]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][0]-tmpImage_ldbl*((fftwl_complex*)a->out)[i][1];
		    ((fftwl_complex*)c->out)[i][1]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][1]+tmpImage_ldbl*((fftwl_complex*)a->out)[i][0];

		    ((fftwl_complex*)c->out)[(a->fft_block_length_int)-i][0]+=tmpReal_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftwl_complex*)c->out)[(a->fft_block_length_int)-i][1]+=tmpReal_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	  	for(i=2;i<((a->fft_block_length_int)/2);i+=2){
	    	tmpReal_ldbl =  ((long double*)b)[                          i];  //Real data
	    	tmpImage_ldbl= -((long double*)b)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftwl_complex*)c->out)[i][0]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][0]-tmpImage_ldbl*((fftwl_complex*)a->out)[i][1];
		    ((fftwl_complex*)c->out)[i][1]+=tmpReal_ldbl*((fftwl_complex*)a->out)[i][1]+tmpImage_ldbl*((fftwl_complex*)a->out)[i][0];

		    ((fftwl_complex*)c->out)[(a->fft_block_length_int)-i][0]+=tmpReal_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftwl_complex*)c->out)[(a->fft_block_length_int)-i][1]+=tmpReal_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	}

//calculate before center tap
//c.in = a.out * rev(b)
void fft_rev_mul_Filter(Fftv* a,void* b,Fftv* c) 
{
	switch(a->precision_int){
		case FLOAT_PRECISION:
			fft_rev_mulf_CxFilter(a,b,c);
		break;
		case DOUBLE_PRECISION:
			fft_rev_mul_CxFilter(a,b,c);
		break;
		case LONG_DOUBLE_PRECISION:
			fft_rev_mull_CxFilter(a,b,c);
		break;	

	}
}

	void fft_rev_mulf_CxFilter(Fftv* a,void* b,Fftv* c)
	{
		printf("||| fft_rev_mulf_CxR \n");
		
		float tmpReal_fl,tmpImage_fl;
		int i=0;
	  	tmpReal_fl =((float*)b)[                          0];
	  	tmpImage_fl=0;
	    ((fftwf_complex*)c->out)[i][0]=tmpReal_fl*((fftwf_complex*)a->out)[i][0]-tmpImage_fl*((fftwf_complex*)a->out)[i][1];
	    ((fftwf_complex*)c->out)[i][1]=tmpReal_fl*((fftwf_complex*)a->out)[i][1]+tmpImage_fl*((fftwf_complex*)a->out)[i][0];

	  	i=(a->fft_block_length_int)/2;
	  	tmpReal_fl =((float*)b)[(a->fft_block_length_int)/2];
	  	tmpImage_fl=0;
	    ((fftwf_complex*)c->out)[i][0]=tmpReal_fl*((fftwf_complex*)a->out)[i][0]-tmpImage_fl*((fftwf_complex*)a->out)[i][1];
	    ((fftwf_complex*)c->out)[i][1]=tmpReal_fl*((fftwf_complex*)a->out)[i][1]+tmpImage_fl*((fftwf_complex*)a->out)[i][0];
	
	  	for(i=1;i<((a->fft_block_length_int)/2);i+=2){
	    	tmpReal_fl = -((float*)b)[                          i];  //Real data
	    	tmpImage_fl=  ((float*)b)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftwf_complex*)c->out)[i][0]=tmpReal_fl*((fftwf_complex*)a->out)[i][0]-tmpImage_fl*((fftwf_complex*)a->out)[i][1];
		    ((fftwf_complex*)c->out)[i][1]=tmpReal_fl*((fftwf_complex*)a->out)[i][1]+tmpImage_fl*((fftwf_complex*)a->out)[i][0];

		    ((fftwf_complex*)c->out)[(a->fft_block_length_int)-i][0]=tmpReal_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftwf_complex*)c->out)[(a->fft_block_length_int)-i][1]=tmpReal_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	  	for(i=2;i<((a->fft_block_length_int)/2);i+=2){
	    	tmpReal_fl =  ((float*)b)[                          i];  //Real data
	    	tmpImage_fl= -((float*)b)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftwf_complex*)c->out)[i][0]=tmpReal_fl*((fftwf_complex*)a->out)[i][0]-tmpImage_fl*((fftwf_complex*)a->out)[i][1];
		    ((fftwf_complex*)c->out)[i][1]=tmpReal_fl*((fftwf_complex*)a->out)[i][1]+tmpImage_fl*((fftwf_complex*)a->out)[i][0];

		    ((fftwf_complex*)c->out)[(a->fft_block_length_int)-i][0]=tmpReal_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftwf_complex*)c->out)[(a->fft_block_length_int)-i][1]=tmpReal_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_fl*((fftwf_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	}

	void fft_rev_mul_CxFilter(Fftv* a,void* b,Fftv* c)
	{
		double tmpReal_dbl,tmpImage_dbl;
		int i=0;
	  	tmpReal_dbl =((double*)b)[                          0];
	  	tmpImage_dbl=0;
	    ((fftw_complex*)c->out)[i][0]=tmpReal_dbl*((fftw_complex*)a->out)[i][0]-tmpImage_dbl*((fftw_complex*)a->out)[i][1];
	    ((fftw_complex*)c->out)[i][1]=tmpReal_dbl*((fftw_complex*)a->out)[i][1]+tmpImage_dbl*((fftw_complex*)a->out)[i][0];

	  	i=(a->fft_block_length_int)/2;
	  	tmpReal_dbl =((double*)b)[(a->fft_block_length_int)/2];
	  	tmpImage_dbl=0;
	    ((fftw_complex*)c->out)[i][0]=tmpReal_dbl*((fftw_complex*)a->out)[i][0]-tmpImage_dbl*((fftw_complex*)a->out)[i][1];
	    ((fftw_complex*)c->out)[i][1]=tmpReal_dbl*((fftw_complex*)a->out)[i][1]+tmpImage_dbl*((fftw_complex*)a->out)[i][0];
	
	  	for(i=1;i<((a->fft_block_length_int)/2);i+=2){
	    	tmpReal_dbl = -((double*)b)[                          i];  //Real data
	    	tmpImage_dbl=  ((double*)b)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftw_complex*)c->out)[i][0]=tmpReal_dbl*((fftw_complex*)a->out)[i][0]-tmpImage_dbl*((fftw_complex*)a->out)[i][1];
		    ((fftw_complex*)c->out)[i][1]=tmpReal_dbl*((fftw_complex*)a->out)[i][1]+tmpImage_dbl*((fftw_complex*)a->out)[i][0];

		    ((fftw_complex*)c->out)[(a->fft_block_length_int)-i][0]=tmpReal_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftw_complex*)c->out)[(a->fft_block_length_int)-i][1]=tmpReal_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	  	for(i=2;i<((a->fft_block_length_int)/2);i+=2){
	    	tmpReal_dbl =  ((double*)b)[                          i];  //Real data
	    	tmpImage_dbl= -((double*)b)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftw_complex*)c->out)[i][0]=tmpReal_dbl*((fftw_complex*)a->out)[i][0]-tmpImage_dbl*((fftw_complex*)a->out)[i][1];
		    ((fftw_complex*)c->out)[i][1]=tmpReal_dbl*((fftw_complex*)a->out)[i][1]+tmpImage_dbl*((fftw_complex*)a->out)[i][0];

		    ((fftw_complex*)c->out)[(a->fft_block_length_int)-i][0]=tmpReal_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftw_complex*)c->out)[(a->fft_block_length_int)-i][1]=tmpReal_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_dbl*((fftw_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	}
	
	void fft_rev_mull_CxFilter(Fftv* a,void* b,Fftv* c)
	{
		long double tmpReal_ldbl,tmpImage_ldbl;
		int i=0;
	  	tmpReal_ldbl =((long double*)b)[                          0];
	  	tmpImage_ldbl=0;
	    ((fftwl_complex*)c->out)[i][0]=tmpReal_ldbl*((fftwl_complex*)a->out)[i][0]-tmpImage_ldbl*((fftwl_complex*)a->out)[i][1];
	    ((fftwl_complex*)c->out)[i][1]=tmpReal_ldbl*((fftwl_complex*)a->out)[i][1]+tmpImage_ldbl*((fftwl_complex*)a->out)[i][0];

	  	i=(a->fft_block_length_int)/2;
	  	tmpReal_ldbl =((long double*)b)[(a->fft_block_length_int)/2];
	  	tmpImage_ldbl=0;
	    ((fftwl_complex*)c->out)[i][0]=tmpReal_ldbl*((fftwl_complex*)a->out)[i][0]-tmpImage_ldbl*((fftwl_complex*)a->out)[i][1];
	    ((fftwl_complex*)c->out)[i][1]=tmpReal_ldbl*((fftwl_complex*)a->out)[i][1]+tmpImage_ldbl*((fftwl_complex*)a->out)[i][0];
	
	  	for(i=1;i<((a->fft_block_length_int)/2);i+=2){
	    	tmpReal_ldbl = -((long double*)b)[                          i];  //Real data
	    	tmpImage_ldbl=  ((long double*)b)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftwl_complex*)c->out)[i][0]=tmpReal_ldbl*((fftwl_complex*)a->out)[i][0]-tmpImage_ldbl*((fftwl_complex*)a->out)[i][1];
		    ((fftwl_complex*)c->out)[i][1]=tmpReal_ldbl*((fftwl_complex*)a->out)[i][1]+tmpImage_ldbl*((fftwl_complex*)a->out)[i][0];

		    ((fftwl_complex*)c->out)[(a->fft_block_length_int)-i][0]=tmpReal_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftwl_complex*)c->out)[(a->fft_block_length_int)-i][1]=tmpReal_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	  	for(i=2;i<((a->fft_block_length_int)/2);i+=2){
	    	tmpReal_ldbl =  ((long double*)b)[                          i];  //Real data
	    	tmpImage_ldbl= -((long double*)b)[(a->fft_block_length_int)-i];  //Image data
	
		    ((fftwl_complex*)c->out)[i][0]=tmpReal_ldbl*((fftwl_complex*)a->out)[i][0]-tmpImage_ldbl*((fftwl_complex*)a->out)[i][1];
		    ((fftwl_complex*)c->out)[i][1]=tmpReal_ldbl*((fftwl_complex*)a->out)[i][1]+tmpImage_ldbl*((fftwl_complex*)a->out)[i][0];

		    ((fftwl_complex*)c->out)[(a->fft_block_length_int)-i][0]=tmpReal_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][0]+tmpImage_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][1];
		    ((fftwl_complex*)c->out)[(a->fft_block_length_int)-i][1]=tmpReal_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][1]-tmpImage_ldbl*((fftwl_complex*)a->out)[(a->fft_block_length_int)-i][0];
		}
	}



