/* FUSE(FastUpSamplingEngin) was written by choi on Nov.23,2004.
 *                                   (this version: Jan.7,2007)
 * You can contact them at http://sak2-2.tok2.com/home/choi/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef CONVTEST_H_
#define CONVTEST_H_

#endif /*CONVTEST_H_*/
#include "fftw3.h"

#define FW	0
#define BW	1
#define MAINLOBE	0
#define SIDELOBE	1

#define WISDOM_BUF_SIZE 10000
#define WISDOM_ERROR_MIN  100
#define PRECISIONSUFFIX	"     "
#define FLOATPRECISIONSUFFIX	"_fl"
#define DOUBLEPRECISIONSUFFIX	"_dbl"
#define LDOUBLEPRECISIONSUFFIX	"_ldbl"

#define WISDOMDIRECTIONFORWARDSUFFIX	"_fw"
#define WISDOMDIRECTIONBACKWARDSUFFIX	"_bw"
//#define WISDOMDIRECTIONFORWARDSUFFIX	""
//#define WISDOMDIRECTIONBACKWARDSUFFIX	""
#define TRANSFORMKINDDFTSUFFIX	""
#define TRANSFORMKINDR2RSUFFIX	"_ms"


#define WISDOMDIRNAME			"wisdom"
//transform_kind_cp
#define DFT					"dft"
#define REAL2REAL				"r2r"

#define DONT_ALLOCATE_MEMORY	true
#define ALLOCATE_MEMORY		false

#define SAVE_WISDOM			true
#define NOTSAVE_WISDOM			false

#define DEFAULT_OPTIMIZE_FLAG	FFTW_PRESERVE_INPUT

typedef struct {
	void*	fftwplan;
	char*	fuseexe_cp;
	int 	precision_int;
	char* 	transform_kind_cp;
	int 	main_or_sidelobe_int;
	int 	direction_int;
	int 	optimize_int;
	int 	fft_block_length_int;
	void* 	in;
	void* 	out;
	
	char*	wisdom_filename_cp;
	char*	wisdom_string_cp;
	
	int		in_malloc_int;
	int		out_malloc_int;

} Fftv;

void init_conv(Fftv*);
//void* init_conv(char*,int,char*,int,int,int,int,void*,void*);
//fftwf_plan void* init_conv(char*,int,char*,int,int,int,double*,double*);
//fftw_plan  void* init_conv(char*,int,char*,int,int,int,fftw_complex*,fftw_complex*);

void print_wisdom(Fftv*);

//void add_conv(double,double);
void print_conv(Fftv*);
//void free_conv(void);

void fftexe(Fftv*);
void fftfree(Fftv*);
void fftinfree(Fftv*);

void fft_mul(Fftv*,Fftv*,Fftv*);
//fft_mul(Fftv* a,Fftv* b,Fftv* c);  c.out=a.out*b.out
	void fft_mulf_CxC(Fftv*,Fftv*,Fftv*);
	void fft_mul_CxC(Fftv*,Fftv*,Fftv*);
	void fft_mull_CxC(Fftv*,Fftv*,Fftv*);
	
	void fft_mulf_RxR(Fftv*,Fftv*,Fftv*);
	void fft_mul_RxR(Fftv*,Fftv*,Fftv*);
	void fft_mull_RxR(Fftv*,Fftv*,Fftv*);

	void fft_mulf_CxR(Fftv*,Fftv*,Fftv*);
	void fft_mul_CxR(Fftv*,Fftv*,Fftv*);
	void fft_mull_CxR(Fftv*,Fftv*,Fftv*);

void fft_mul_Filter(Fftv*,void*,Fftv*);
//fft_mul(Fftv* a,void* b,Fftv* c);  c.out+=a.out*b
	void fft_mulf_CxFilter(Fftv*,void*,Fftv*);
	void fft_mul_CxFilter(Fftv*,void*,Fftv*);
	void fft_mull_CxFilter(Fftv*,void*,Fftv*);

void fft_mul_add_Filter(Fftv*,void*,Fftv*);
//fft_mul(Fftv* a,void* b,Fftv* c);  c.out+=a.out*b
	void fft_mulf_add_CxFilter(Fftv*,void*,Fftv*);
	void fft_mul_add_CxFilter(Fftv*,void*,Fftv*);
	void fft_mull_add_CxFilter(Fftv*,void*,Fftv*);

//calculate after impulse
void fft_rev_mul_add(Fftv*,Fftv*,Fftv*);
//fft_rev_mul_add(Fftv* a,Fftv* b,Fftv* c) 
//c.in += a.out * rev(b.out)
	void fft_rev_mulf_add_CxC(Fftv*,Fftv*,Fftv*);
	void fft_rev_mul_add_CxC(Fftv*,Fftv*,Fftv*);
	void fft_rev_mull_add_CxC(Fftv*,Fftv*,Fftv*);
	
	void fft_rev_mulf_add_RxR(Fftv*,Fftv*,Fftv*);
	void fft_rev_mul_add_RxR(Fftv*,Fftv*,Fftv*);
	void fft_rev_mull_add_RxR(Fftv*,Fftv*,Fftv*);
	
	void fft_rev_mulf_add_CxR(Fftv*,Fftv*,Fftv*);
	void fft_rev_mul_add_CxR(Fftv*,Fftv*,Fftv*);
	void fft_rev_mull_add_CxR(Fftv*,Fftv*,Fftv*);
	
void fft_rev_mul_add_Filter(Fftv*,void*,Fftv*);
//fft_rev_mul_add_Filter(Fftv* a,void* b,Fftv* c) 
//c.in += a.out * rev(b)
	void fft_rev_mulf_add_CxFilter(Fftv*,void*,Fftv*);
	void fft_rev_mul_add_CxFilter(Fftv*,void*,Fftv*);
	void fft_rev_mull_add_CxFilter(Fftv*,void*,Fftv*);

void fft_rev_mul_Filter(Fftv*,void*,Fftv*);
//fft_rev_mul_Filter(Fftv* a,void* b,Fftv* c) 
//c.in = a.out * rev(b)
	void fft_rev_mulf_CxFilter(Fftv*,void*,Fftv*);
	void fft_rev_mul_CxFilter(Fftv*,void*,Fftv*);
	void fft_rev_mull_CxFilter(Fftv*,void*,Fftv*);
