/* FUSE(FastUpSamplingEngin) was written by choi on Nov.23,2004.
 *                                   (this version: Jan.7,2007)
 * You can contact them at http://sak2-2.tok2.com/home/choi/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef CONVTEST_H_
#define CONVTEST_H_

#endif /*CONVTEST_H_*/
#include "fftw3.h"

#define FW	0
#define BW	1
#define MAINLOBE	0
#define SIDELOBE	1

#define WISDOM_BUF_SIZE 10000
#define WISDOM_ERROR_MIN  100
#define PRECISIONSUFFIX	"     "
#define FLOATPRECISIONSUFFIX	"_fl"
#define DOUBLEPRECISIONSUFFIX	"_dbl"
#define LDOUBLEPRECISIONSUFFIX	"_ldbl"

#define WISDOMDIRECTIONFORWARDSUFFIX	"_fw"
#define WISDOMDIRECTIONBACKWARDSUFFIX	"_bw"
//#define WISDOMDIRECTIONFORWARDSUFFIX	""
//#define WISDOMDIRECTIONBACKWARDSUFFIX	""
#define TRANSFORMKINDDFTSUFFIX	""
#define TRANSFORMKINDR2RSUFFIX	"_ms"


#define WISDOMDIRNAME	"wisdom"
//transform_kind_cp
#define DFT	"dft"
#define REAL2REAL	"r2r"



typedef struct {
	void*	fftwplan;
	char*	fuseexe_cp;
	int 	precision_int;
	char* 	transform_kind_cp;
	int 	main_or_sidelobe_int;
	int 	direction_int;
	int 	optimize_int;
	int 	fft_block_length_int;
	void* 	in;
	void* 	out;
	
	char*	wisdom_filename_cp;
	char*	wisdom_string_cp;
	
	int		in_malloc_int;
	int		out_malloc_int;

} Fftv;

void init_conv(Fftv*);
//void* init_conv(char*,int,char*,int,int,int,int,void*,void*);
//fftwf_plan void* init_conv(char*,int,char*,int,int,int,double*,double*);
//fftw_plan  void* init_conv(char*,int,char*,int,int,int,fftw_complex*,fftw_complex*);

void print_wisdom(Fftv*);

//void add_conv(double,double);
void print_conv(Fftv*);
//void free_conv(void);

void fftexe(Fftv*);
void fftfree(Fftv*);
void fftinfree(Fftv*);//gfilter.inƁAmain.in,side.inpق悢

void fftmul(Fftv*,Fftv*);//a.out*b.out
	void complexf_mul(Fftv*,Fftv*);
	void complex_mul(Fftv*,Fftv*);
	void complexl_mul(Fftv*,Fftv*);
	
	void halfcomplexf_mul(Fftv*,Fftv*);
	void halfcomplex_mul(Fftv*,Fftv*);
	void halfcomplexl_mul(Fftv*,Fftv*);


