/* FUSE(FastUpSamplingEngin) was written by choi on Nov.23,2004.
 *                                   (this version: Jan.7,2007)
 * You can contact them at http://sak2-2.tok2.com/home/choi/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifndef unix
#include <conio.h>
#include <io.h>
#endif
#include <math.h>

#include "convolution.h"
#include "cputype.h"
#include "fftw3.h"
#include "define.h"
#include "soundfile.h"

//#define _DEBUGFFTSOUNDFILE


int fft_soundfile(char* original_filename_cp
	,char* ffted_filename_cp
	,char* av0_cp
	,int overtimes_int
	,int tap_exp_int
	,int div_int
	,int optimize_int)
{
	int block_exp_int=tap_exp_int-(int)log2(div_int)+1;
	int j,k;
	short	data_sht[]={0,0};//16bit 2ch


//	int read_samples_at_a_time_int
//		=(int)pow(2,block_exp_int-1)/overtimes_int/CHANNELS;
		
	#ifdef _DEBUGFFTSOUNDFILE
	printf("overtimes x%d\n",overtimes_int);
	printf("tap ^%d\n",tap_exp_int);
	printf("div /%d\n",div_int);

	printf("block_exp_int /%d\n",block_exp_int);
	printf("filter_exp_int /%d\n",block_exp_int-1);
//  block={[fn][00]}
	printf("read_samples_at_a_time exp ^/%d\n",(int)log2((int)pow(2,block_exp_int-1)/overtimes_int/2));
	#endif

	FILE* original_Fp;
	WaveChunk original_WC  ={"    ",0,"    ","    ",0,0,0,0,0,0,0,"    ",0,0};
	if ((original_Fp = fopen(original_filename_cp,"rb")) == NULL) {printf("%s\n",original_filename_cp);return(-1);}
//	read_wav_chunk(original_Fp,&original_WC,false);
	read_wav_chunk(original_Fp,&original_WC,true);


	FILE* ffted_Fp;
	if ((ffted_Fp = fopen(ffted_filename_cp, "wb")) == NULL) {printf("Cannot open. %s\n",ffted_filename_cp);return(-1);}

	
//	float* tmp_fl;	tmp_fl  = (float *)malloc((int)pow(2,block_exp_int)*2*sizeof(float));//float 2ch
//	if(tmp_fl  == NULL) { printf("mۂł܂\n"); exit(1);}


//	fftw
	Fftv side;
	side.fuseexe_cp=av0_cp;
	side.transform_kind_cp  =DFT;
	side.optimize_int=optimize_int;
	side.fft_block_length_int=(int)pow(2,block_exp_int);
	side.precision_int=FLOAT_PRECISION;
	side.main_or_sidelobe_int=SIDELOBE;	
	side.direction_int=FW;
	side.in_malloc_int=ALLOCATE_MEMORY;
	side.out_malloc_int=ALLOCATE_MEMORY;
	printf("init_conv start ===================================\n");
//	getch();
	init_conv(&side);
	printf("init_conv fin ===================================\n");
//	getch();


	//###########################################
	for(int j=0;j<side.fft_block_length_int;j++){
		((fftwf_complex*)side.out)[j][0]=	0;
		((fftwf_complex*)side.out)[j][1]=	0;
	}
	for(j=0;j<(div_int-1)/2-1;j++){
//	for(j=0;j<(div_int-3);j++){
		fwrite(side.out,sizeof(float)
		,side.fft_block_length_int*STEREO,ffted_Fp);
	}
	//########################################### 

//	int half_block_length_int=side.fft_block_length_int/2;


	for(j=(side.fft_block_length_int/2);j<side.fft_block_length_int;j++){
		((fftwf_complex*)side.in)[j][0]=0;
		((fftwf_complex*)side.in)[j][1]=0;
	}


//	int count_int=0;
//	int count2_int=0;

	for(unsigned long i_ul=0;i_ul<original_WC.Data_chunkSize_ul
		/((unsigned long)(original_WC.Fmt_wBitsPerSample_usht*original_WC.Fmt_nChannels_usht/8)
		*(unsigned long)((int)pow(2,block_exp_int-1)/overtimes_int))
		;i_ul++
		){

		#ifdef _DEBUGFFTSOUNDFILE
			printf("i_ul %ld \n",i_ul);
		#endif
		
		for( j=0;j<(side.fft_block_length_int/2);j++){
			((fftwf_complex*)side.in)[j][0]=((fftwf_complex*)side.in)[j+(side.fft_block_length_int/2)][0];
			((fftwf_complex*)side.in)[j][1]=((fftwf_complex*)side.in)[j+(side.fft_block_length_int/2)][1];
		}
			
		for( j=(side.fft_block_length_int/2);j<side.fft_block_length_int;j+=overtimes_int){
		//read samples from original file
			fread(&data_sht[0],sizeof(short),2,original_Fp);
			((fftwf_complex*)side.in)[j][0]=(float)data_sht[0];
			((fftwf_complex*)side.in)[j][1]=(float)data_sht[1];

//			fread(&((fftwf_complex*)side.in)[j][0],sizeof(short),1,original_Fp);
//			fread(&((fftwf_complex*)side.in)[j][1],sizeof(short),1,original_Fp);

			for(k=1;k<overtimes_int;k++){
			//fill 0
			((fftwf_complex*)side.in)[j+k][0]=	0;
			((fftwf_complex*)side.in)[j+k][1]=	0;
			}
		}
//		count_int++;

		#ifdef _DEBUGFFTSOUNDFILE
		fwrite(side.in,sizeof(float)
			,(int)pow(2,block_exp_int)*2,ffted_Fp);//2ch

		#endif

		#ifndef _DEBUGFFTSOUNDFILE
		fftexe(&side);
		fwrite(side.out,sizeof(float)
			,(int)pow(2,block_exp_int)*2,ffted_Fp);//2ch
		#endif

	}


	
	if((int)(original_WC.Data_chunkSize_ul
		%((unsigned long)(original_WC.Fmt_wBitsPerSample_usht*original_WC.Fmt_nChannels_usht/8)
		*(unsigned long)((int)pow(2,block_exp_int-1)/overtimes_int))
		/(int)(original_WC.Fmt_wBitsPerSample_usht*original_WC.Fmt_nChannels_usht/8))
		*overtimes_int
		>0){

			for( j=0;j<(side.fft_block_length_int/2);j++){
				((fftwf_complex*)side.in)[j][0]=((fftwf_complex*)side.in)[j+(side.fft_block_length_int/2)][0];
				((fftwf_complex*)side.in)[j][1]=((fftwf_complex*)side.in)[j+(side.fft_block_length_int/2)][1];
			}

			j=0;
			while(j<(int)(original_WC.Data_chunkSize_ul
				%((unsigned long)(original_WC.Fmt_wBitsPerSample_usht*original_WC.Fmt_nChannels_usht/8)
				*(unsigned long)((int)pow(2,block_exp_int-1)/overtimes_int))
				/(int)(original_WC.Fmt_wBitsPerSample_usht*original_WC.Fmt_nChannels_usht/8))
				*overtimes_int){
					
					fread(&data_sht[0],sizeof(short),2,original_Fp);
					((fftwf_complex*)side.in)[j+(side.fft_block_length_int/2)][0]=(float)data_sht[0];
					((fftwf_complex*)side.in)[j+(side.fft_block_length_int/2)][1]=(float)data_sht[1];
					
//					fread(&((fftwf_complex*)side.in)[j+(side.fft_block_length_int/2)][0],sizeof(short),1,original_Fp);
//					fread(&((fftwf_complex*)side.in)[j+(side.fft_block_length_int/2)][1],sizeof(short),1,original_Fp);

					for(k=1;k<overtimes_int;k++){
					//fill 0
						((fftwf_complex*)side.in)[j+(side.fft_block_length_int/2)+k][0]=	0;
						((fftwf_complex*)side.in)[j+(side.fft_block_length_int/2)+k][1]=	0;
					}

//					count2_int++;
					j+=overtimes_int;
			}
			while( j<(side.fft_block_length_int/2) ){

				#ifdef _DEBUGFFTSOUNDFILE
				printf("%d %d %d\n",j,j+side.fft_block_length_int/2,side.fft_block_length_int);
				#endif
 
				((fftwf_complex*)side.in)[j+(side.fft_block_length_int/2)][0]=	0;
				((fftwf_complex*)side.in)[j+(side.fft_block_length_int/2)][1]=	0;

				for(k=1;k<overtimes_int;k++){
				//fill 0
					((fftwf_complex*)side.in)[j+(side.fft_block_length_int/2)+k][0]=	0;
					((fftwf_complex*)side.in)[j+(side.fft_block_length_int/2)+k][1]=	0;
				}
				j+=overtimes_int;
			}

//			printf("%d %d %d\n",j,j+side.fft_block_length_int/2,side.fft_block_length_int);
//			getch();			
			
			#ifdef _DEBUGFFTSOUNDFILE
			fwrite(side.in,sizeof(float)
				,(int)pow(2,block_exp_int)*2,ffted_Fp);//2ch
			#endif

			#ifndef _DEBUGFFTSOUNDFILE
			fftexe(&side);
			fwrite(side.out,sizeof(float)
				,(int)pow(2,block_exp_int)*2,ffted_Fp);//2ch
			#endif
	}



	for(j=0;j<(side.fft_block_length_int/2);j++){
		((fftwf_complex*)side.in)[j][0]=((fftwf_complex*)side.in)[j+(side.fft_block_length_int/2)][0];
		((fftwf_complex*)side.in)[j][1]=((fftwf_complex*)side.in)[j+(side.fft_block_length_int/2)][1];
	}
			
	for(j=(side.fft_block_length_int/2);j<side.fft_block_length_int;j++){
		((fftwf_complex*)side.in)[j][0]=	0;
		((fftwf_complex*)side.in)[j][1]=	0;
	}

	#ifdef _DEBUGFFTSOUNDFILE
	fwrite(side.in,sizeof(float)
		,(int)pow(2,block_exp_int)*2,ffted_Fp);//2ch
	#endif

	#ifndef _DEBUGFFTSOUNDFILE
	fftexe(&side);
	fwrite(side.out,sizeof(float)
		,(int)pow(2,block_exp_int)*2,ffted_Fp);//2ch
	#endif



	//###########################################
	for(j=0;j<side.fft_block_length_int;j++){
		((fftwf_complex*)side.out)[j][0]=	0;
		((fftwf_complex*)side.out)[j][1]=	0;
	}
//	for(j=0;j<(div_int-1)/2-1;j++){
	for(j=0;j<(div_int);j++){
		fwrite(side.out,sizeof(float)
		,side.fft_block_length_int*STEREO,ffted_Fp);
	}
	//########################################### 


	/*
	while(!feof(original_Fp)){
		fread(tmp_fl,sizeof(short)
			,(int)pow(2,block_exp_int-1)/overtimes_int,original_Fp);
//	printf("%d Byte read\n",read_samples_at_a_time_int*2*sizeof(float));
//	fwrite(tmp_cp,sizeof(char),(int)pow(2,block_exp_int)*4*2,ffted_Fp);

//		fwrite(tmp_fl,sizeof(float)
//			,(int)pow(2,block_exp_int)*2,ffted_Fp);//2ch

//	printf("%d Byte write\n",(int)pow(2,block_exp_int)*2*sizeof(float));
//  6sec@128MB(block_exp=24) write (notePC)

//		count_int++;

	}
	
	*/

	fclose(original_Fp);
	fclose(ffted_Fp);
	fftfree(&side);

//	printf("count_int=%d\n",count_int);
//	printf("count2_int=%d\n",count2_int);

//	printf("bytes %d\n",count_int* (int)(original_WC.Fmt_wBitsPerSample_usht*original_WC.Fmt_nChannels_usht/8)*(int)pow(2,tap_exp_int)/div_int/overtimes_int+count2_int);

//	getch();
	return 1;
}








