/* FUSE(FastUpSamplingEngin) was written by choi on Nov.23,2004.
 *                                   (this version: Jan.7,2007)
 * You can contact them at http://sak2-2.tok2.com/home/choi/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifndef unix
#include <conio.h>
#include <io.h>
#endif
#include <math.h>

#include "convolution.h"
#include "cputype.h"
#include "fftw3.h"
#include "define.h"
#include "soundfile.h"


#include "define.h"
#include "printime.h"
#include "printmessage.h"
//#include "convolution.h"
#include "cputype.h"
#include "fftw3.h"

#include "makeallfilters.h"



#define _DEBUGIFFTSOUNDFILE
#define  MAINLOBEEXPTAPS	18
//#define _ELIMINATEMAINLOBE

//#define _MAINLOBEONLY

double ifft_soundfile(
	char* original_filename_cp
	,char* ffted_filename_cp
	,char* converted_filename_cp
	,char* av0_cp
	,int overtimes_int
	,int filter_length_exp_int
	,int div_int
	,double cosine_rolloff_factor_dbl)
{
	double out_wave_absmax_dbl=0; 
	int optimize_int=1;

	int block_exp_int=filter_length_exp_int-(int)log2((div_int/2)*2)+1;
//	int sidelobe_ifft_conv_block_int=STEREO*(int)pow(2,block_exp_int-1);
	int sidelobe_ifft_conv_block_int=(int)pow(2,block_exp_int);
	int sidelobe_half_block_int=(int)pow(2,block_exp_int)/2;

//	int mainlobe_ifft_conv_block_int=(int)(pow(2,MAINLOBEEXPTAPS));
	int mainlobe_half_block_int=(int)pow(2,MAINLOBEEXPTAPS)/2;

	short	data_sht[]={0,0};//16bit 2ch
	

//	int read_samples_at_a_time_int
//		=(int)pow(2,block_exp_int-1)/overtimes_int/CHANNELS;
		
	#ifdef _DEBUGIFFTSOUNDFILE
	printf("overtimes x%d\n",overtimes_int);
	printf("tap ^%d\n",filter_length_exp_int);
	printf("div /%d\n",div_int);

	printf("block_exp_int /%d\n",block_exp_int);
	printf("filter_exp_int /%d\n",block_exp_int-1);
//  block={[fn][00]}
	printf("read_samples_at_a_time exp ^/%d\n",(int)log2((int)pow(2,block_exp_int-1)/overtimes_int/2));
	#endif

	Filter f ={0,0,av0_cp,filter_length_exp_int,MAINLOBEEXPTAPS	,overtimes_int,cosine_rolloff_factor_dbl,div_int,optimize_int};
//	Filter f ={0,0,av0_cp,filter_length_exp_int,0				,overtimes_int,-1,div_int,optimize_int};
/* 	double*		main_filter_r2r;
	float**		side_filter_r2r;
	char*		argv0_cp;	 
	int 	filter_length_exp_int;
	int 	eliminate_exp_int;
	int 	overtimes_int;
	double cosine_rolloff_factor_dbl; //default:-1
	int 	div_int;
	int 	optimize_int;
*/

	makeallfilters(&f);

	FILE* original_Fp;
	WaveChunk original_WC  ={"    ",0,"    ","    ",0,0,0,0,0,0,0,"    ",0,0};
	if ((original_Fp = fopen(original_filename_cp,"rb")) == NULL) {printf("%s\n",original_filename_cp);return(-1);}
	#ifndef _DEBUGIFFTSOUNDFILE
	read_wav_chunk(original_Fp,&original_WC,false);
	#endif
	#ifdef _DEBUGIFFTSOUNDFILE
	read_wav_chunk(original_Fp,&original_WC,true);
	#endif

	long long mainlobe_remainder_samples_ll=original_WC.Data_chunkSize_ul/(unsigned long)original_WC.Fmt_nBlockAlign_usht;
	long long converted_remainder_samples_ll=mainlobe_remainder_samples_ll*overtimes_int;

	FILE* ffted_Fp;
	if ((ffted_Fp = fopen(ffted_filename_cp,"rb")) == NULL) {printf("Cannot open. %s\n",ffted_filename_cp);return(-1);}

	FILE* converted_Fp;
//	WaveChunk converted_WC  ={"RIFF",0,"WAVE","fmt ",16,LPCM,STEREO,44100*overtimes_int,44100*overtimes_int*sizeof(float)*STEREO,sizeof(float)*STEREO,sizeof(float)*8,"data",0,WAV_HEADER_SIZE_DEFAULT};
	if ((converted_Fp = fopen(converted_filename_cp, "wb")) == NULL) {printf("Cannot open. %s\n",converted_filename_cp);return(-1);}
//	write_wav_chunk(converted_Fp,&converted_WC,1,true);


	
	Fftv sidebuf={	0,	av0_cp,	FLOAT_PRECISION,	DFT,	SIDELOBE,	FW,optimize_int,(int)pow(2,block_exp_int)	,0,0,"","",DONT_ALLOCATE_MEMORY	,ALLOCATE_MEMORY};
	Fftv sideifft={	0,	av0_cp,	FLOAT_PRECISION,	DFT,	SIDELOBE,	BW,optimize_int,(int)pow(2,block_exp_int)	,0,0,"","",ALLOCATE_MEMORY		,ALLOCATE_MEMORY};

	Fftv main	={	0,	av0_cp,	DOUBLE_PRECISION,	DFT,	MAINLOBE,	FW,optimize_int,(int)pow(2,MAINLOBEEXPTAPS)	,0,0,"","",ALLOCATE_MEMORY		,ALLOCATE_MEMORY};
	Fftv mainifft={	0,	av0_cp,	DOUBLE_PRECISION,	DFT,	MAINLOBE,	BW,optimize_int,(int)pow(2,MAINLOBEEXPTAPS)	,0,0,"","",ALLOCATE_MEMORY		,ALLOCATE_MEMORY};

	#ifdef _DEBUGIFFTSOUNDFILE
	printf("init_conv start ===================================\n");
	#endif

	init_conv(&sidebuf);
	init_conv(&sideifft);
	init_conv(&main);
	init_conv(&mainifft);


	#ifdef _DEBUGIFFTSOUNDFILE
	printf("init_conv fin ===================================\n");
	#endif

	

	for(int j=0;j<mainlobe_half_block_int;j++){
		((fftw_complex*)main.in)[j][0]=0;
		((fftw_complex*)main.in)[j][1]=0;
	}
	#ifdef _DEBUGIFFTSOUNDFILE
	printf("clear mainlobe half block fin ===================================\n");
	#endif
	
	for(int j=mainlobe_half_block_int;j<mainlobe_half_block_int*2;j+=overtimes_int){

		if(mainlobe_remainder_samples_ll>0){
			fread(&data_sht[0],sizeof(short),STEREO,original_Fp);
			((fftw_complex*)main.in)[j][0]=(double)data_sht[0];
			((fftw_complex*)main.in)[j][1]=(double)data_sht[1];
			mainlobe_remainder_samples_ll--;
		}else{
			((fftw_complex*)main.in)[j][0]=0;
			((fftw_complex*)main.in)[j][1]=0;
		}
		
		for(int k=1;k<overtimes_int;k++){
			((fftw_complex*)main.in)[j+k][0]=0;
			((fftw_complex*)main.in)[j+k][1]=0;
		}//for k

	}//for j
	#ifdef _DEBUGIFFTSOUNDFILE
	printf("read mainlobe half block fin ===================================\n");
	#endif
	
	fftexe(&main);

	#ifdef _DEBUGIFFTSOUNDFILE
	printf("fftexe main fin ===================================\n");
	#endif


//	int readside_int=0;

	////side loop
//	while((readside_int=fread(sidebuf.out,sizeof(float),sidelobe_ifft_conv_block_int*STEREO,ffted_Fp))==sidelobe_ifft_conv_block_int*STEREO){
	while(1){

 		fread(sidebuf.out,sizeof(float),sidelobe_ifft_conv_block_int*STEREO,ffted_Fp);
		fft_mul_Filter(&sidebuf,&f.side_filter_r2r[(div_int-1)/2-1][0],&sideifft);


		for(int ii=(div_int-1)/2-2;ii>-1;ii--){
			#ifdef _DEBUGIFFTSOUNDFILE
			printf("fft_mul_add_Filter side %d ==========\r",ii);
			#endif
			fread(sidebuf.out,sizeof(float),sidelobe_ifft_conv_block_int*STEREO,ffted_Fp);
			fft_mul_add_Filter(&sidebuf,&f.side_filter_r2r[ii][0],&sideifft);
		}


		for(int ii=0;ii<(div_int-1)/2;ii++){
			#ifdef _DEBUGIFFTSOUNDFILE
			printf("fft_rev_mul_add_Filter side %d ==========\r",ii);
			#endif
			fread(sidebuf.out,sizeof(float),sidelobe_ifft_conv_block_int*STEREO,ffted_Fp);
			fft_rev_mul_add_Filter(&sidebuf,&f.side_filter_r2r[ii][0],&sideifft);
		}

//		fseek( ffted_Fp, -(long)sizeof(float)*(long)sidelobe_ifft_conv_block_int*STEREO*(div_int-2-div_int/2),SEEK_CUR);
		fseek( ffted_Fp, -(long)sizeof(float)*(long)sidelobe_ifft_conv_block_int*STEREO*(div_int-2),SEEK_CUR);


		fftexe(&sideifft);

/*		#ifdef _DEBUGIFFTSOUNDFILE
		printf("readside_int:%d/%d\n",readside_int,sidelobe_ifft_conv_block_int*STEREO);
		#endif
*/

	////main loop
		for(int i=0;i<(int)pow(2,block_exp_int-MAINLOBEEXPTAPS);i++){

			fft_mul_Filter(&main,&f.main_filter_r2r[0],&mainifft);

			for(int j=0;j<mainlobe_half_block_int;j++){
				((fftw_complex*)main.in)[j][0]=((fftw_complex*)main.in)[j+mainlobe_half_block_int][0];
				((fftw_complex*)main.in)[j][1]=((fftw_complex*)main.in)[j+mainlobe_half_block_int][1];
			}
			for(int j=mainlobe_half_block_int;j<mainlobe_half_block_int*2;j+=overtimes_int){

				if(mainlobe_remainder_samples_ll>0){
					fread(&data_sht[0],sizeof(short),STEREO,original_Fp);
					((fftw_complex*)main.in)[j][0]=(double)data_sht[0];
					((fftw_complex*)main.in)[j][1]=(double)data_sht[1];
					mainlobe_remainder_samples_ll--;
				}else{
					((fftw_complex*)main.in)[j][0]=0;
					((fftw_complex*)main.in)[j][1]=0;
				}
		
				for(int k=1;k<overtimes_int;k++){
					((fftw_complex*)main.in)[j+k][0]=0;
					((fftw_complex*)main.in)[j+k][1]=0;
				}//for k
		
			}//for j
			fftexe(&main);
			fft_rev_mul_add_Filter(&main,&f.main_filter_r2r[0],&mainifft);
			fftexe(&mainifft);
			
			for(int l=0;l<mainlobe_half_block_int;l++){
				
				
			//scaling

				((fftw_complex*)mainifft.in)[mainlobe_half_block_int+l][0]
					=((fftw_complex*)mainifft.in)[mainlobe_half_block_int+l][0]
						/pow(2,MAINLOBEEXPTAPS-(24-16))*256
					+(double)((fftwf_complex*)sideifft.in)[sidelobe_half_block_int+mainlobe_half_block_int*i+l][0]
						/pow(2,filter_length_exp_int-(24-16))*256*(double)(div_int-1)/2;
				((fftw_complex*)mainifft.in)[mainlobe_half_block_int+l][1]
					=((fftw_complex*)mainifft.in)[mainlobe_half_block_int+l][1]
						/pow(2,MAINLOBEEXPTAPS-(24-16))*256
					+(double)((fftwf_complex*)sideifft.in)[sidelobe_half_block_int+mainlobe_half_block_int*i+l][1]
						/pow(2,filter_length_exp_int-(24-16))*256*(double)(div_int-1)/2;

				#ifdef _ELIMINATEMAINLOBE
				((fftw_complex*)mainifft.in)[mainlobe_half_block_int+l][0]
					=(double)((fftwf_complex*)sideifft.in)[sidelobe_half_block_int+mainlobe_half_block_int*i+l][0]
						/pow(2,filter_length_exp_int-(24-16))*256*(double)(div_int-1)/2;
				((fftw_complex*)mainifft.in)[mainlobe_half_block_int+l][1]
					=(double)((fftwf_complex*)sideifft.in)[sidelobe_half_block_int+mainlobe_half_block_int*i+l][1]
						/pow(2,filter_length_exp_int-(24-16))*256*(double)(div_int-1)/2;
				#endif


				if(out_wave_absmax_dbl<	fabs(((fftw_complex*)mainifft.in)[mainlobe_half_block_int+l][0]))
				{
					out_wave_absmax_dbl
					=fabs(((fftw_complex*)mainifft.in)[mainlobe_half_block_int+l][0]);
				}
				if(out_wave_absmax_dbl<	fabs(((fftw_complex*)mainifft.in)[mainlobe_half_block_int+l][1]))
				{
					out_wave_absmax_dbl
					=fabs(((fftw_complex*)mainifft.in)[mainlobe_half_block_int+l][1]);
				}

			}

			//write
			if(converted_remainder_samples_ll<(long long)mainlobe_half_block_int){
				fwrite(&((fftw_complex*)mainifft.in)[mainlobe_half_block_int][0],sizeof(double)
				,converted_remainder_samples_ll*STEREO,converted_Fp);
				converted_remainder_samples_ll=0;
			}else{
				fwrite(&((fftw_complex*)mainifft.in)[mainlobe_half_block_int][0],sizeof(double)
				,mainlobe_half_block_int*STEREO,converted_Fp);
				converted_remainder_samples_ll-=mainlobe_half_block_int;
			}
			if(converted_remainder_samples_ll==0){
				fclose(original_Fp);
				fclose(ffted_Fp);
				fclose(converted_Fp);
		
				fftfree(&sidebuf);
				fftfree(&sideifft);
				fftfree(&main);
				fftfree(&mainifft);
		
				freeallfilters(&f);
				return out_wave_absmax_dbl;
			};
			#ifdef _DEBUGIFFTSOUNDFILE
			printf("*****************fwrite %d fin ===================================\r",i);
			#endif	
			

		}//for i

	}// while sidelobe ifft loop
	

	fclose(original_Fp);
	fclose(ffted_Fp);
	fclose(converted_Fp);

	fftfree(&sidebuf);
	fftfree(&sideifft);
	fftfree(&main);
	fftfree(&mainifft);

	freeallfilters(&f);
	

	return 1;
}








