/* FUSE(FastUpSamplingEngin) was written by choi on Nov.23,2004.
 *                                   (this version: Jan.7,2007)
 * You can contact them at http://sak2-2.tok2.com/home/choi/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
 
//	2006,7,21 cosine_rolloff_factorovertimes_intɔႳ
//		f->cosine_rolloff_factor_dbl
//			=ALPHA_DEFAULT/pow(2,f->filter_length_exp_int)*(double)(f->overtimes_int)*2;//2006,7,21
			
			
#include <stdio.h>
#ifndef unix
#include <conio.h>
#endif
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "convolution.h"

#include "makeallfilters.h"
#include "define.h"

//#define _DEBUGMAKEALLFILTERS
//#define _TMPDIV2
//#define _FILTEROUT

int makeallfilters(Filter* f)
{
	if(f->div_int<3) return false; 

	#ifdef _FILTEROUT
	FILE* test_Fp;
	if ((test_Fp = fopen("d:\\filter.raw","wb")) == NULL) {printf("Cannot open. \n");return(-1);}
	#endif
		
	
	int eliminate_mainlobe_int=(int)pow(2,f->eliminate_exp_int);
		if(f->eliminate_exp_int==0)eliminate_mainlobe_int=0;
	int block_exp_int=f->filter_length_exp_int-(int)log2(f->div_int-1)+1;

	f->main_filter_r2r = (double *)malloc(
		(int)pow(2,f->eliminate_exp_int)
		*sizeof(double)
		);if(f->main_filter_r2r == NULL) { printf("Cannot allocate memory\n"); exit(1);}



	Fftv	main={	0,	f->argv0_cp,	DOUBLE_PRECISION,	DFT,	MAINLOBE,	FW,f->optimize_int,(int)pow(2,f->eliminate_exp_int),0,0,"","",ALLOCATE_MEMORY,ALLOCATE_MEMORY};
	if(main.fft_block_length_int<2)main.optimize_int=0;
	init_conv(&main);

	if(f->cosine_rolloff_factor_dbl < 0){
		f->cosine_rolloff_factor_dbl
			=ALPHA_DEFAULT/pow(2,f->filter_length_exp_int)*(double)(f->overtimes_int)*2;//2006,7,21
	}
	#ifdef _DEBUGMAKEALLFILTERS
	printf("cosine_rolloff_factor_dbl=%le\n",f->cosine_rolloff_factor_dbl);
	getch();
	#endif
	
	makefilter(&main
		,f->overtimes_int
		,f->cosine_rolloff_factor_dbl
		,0
		,0
		);
	
//int makefilter(Fftv* a
//	,int f->overtimes_int
//	,double f->cosine_rolloff_factor_dbl
//	,int distance_from_center_int
//	,int eliminate_mainlobe_int)
//{

	
	#ifndef _DEBUGMAKEALLFILTERS
	fftexe(&main);
	#endif
	
	
	if(	strcmp(main.transform_kind_cp,DFT) ){ 
		// REAL2REAL
		for(int i=0;i<pow(2,f->eliminate_exp_int);i++){
		#ifndef _DEBUGMAKEALLFILTERS
			f->main_filter_r2r[i]=((double*)main.out)[i];
		#endif
		#ifdef _DEBUGMAKEALLFILTERS
			f->main_filter_r2r[i]=((double*)main.in)[i];
		#endif
		}
	}else{
		//DFT
		int j=0;

		#ifndef _DEBUGMAKEALLFILTERS
		for(int i=0;i<main.fft_block_length_int/2+1;i++){
			//switch PRECISION
			f->main_filter_r2r[j++]=((fftw_complex*)main.out)[i][0];
		}
		for(int i=main.fft_block_length_int/2-1;i>0;i--){
			f->main_filter_r2r[j++]=((fftw_complex*)main.out)[i][1];
		}
		if(j!=main.fft_block_length_int) printf("makeallfilter error \n");
		#endif	

		#ifdef _DEBUGMAKEALLFILTERS
		for(int i=0;i<main.fft_block_length_int;i++){
			f->main_filter_r2r[j++]=((fftw_complex*)main.in)[i][0];
		}
		if(j!=main.fft_block_length_int) printf("makeallfilter error \n");
		#endif
	}
	
	
	fftfree(&main);
	#ifdef _DEBUGMAKEALLFILTERS
		printf("fftfree main\n");
	#endif
	
	f->side_filter_r2r    = (float**)malloc(sizeof(float*)*(f->div_int-1)/2);
	f->side_filter_r2r[0] = (float*)malloc(sizeof(float)*(f->div_int-1)/2*(int)pow(2,block_exp_int));
	if(f->side_filter_r2r[0]==NULL){ printf("Cannot allocate memory\n"); exit(1);}
	for(int i=1;i<(f->div_int-1)/2;i++){
		f->side_filter_r2r[i]=f->side_filter_r2r[i-1]+(int)pow(2,block_exp_int);
	}

	Fftv	side={	0,	f->argv0_cp,	FLOAT_PRECISION,	DFT,	SIDELOBE,	FW,f->optimize_int,(int)pow(2,block_exp_int),0,0,"","",ALLOCATE_MEMORY,ALLOCATE_MEMORY};

	#ifdef _DEBUGMAKEALLFILTERS
		printf("init conv side start\n");
	#endif

	init_conv(&side);
	
	#ifdef _DEBUGMAKEALLFILTERS
		printf("init conv side fin\n");
	#endif
	
	for(int k=0;k<(f->div_int-1)/2;k++){
		
		#ifdef _DEBUGMAKEALLFILTERS
			printf("side loop %d\n",k);
		#endif
		
		
		if(k==0){
			makefilter(&side,f->overtimes_int,f->cosine_rolloff_factor_dbl,0,eliminate_mainlobe_int);
		}else{
			makefilter(&side,f->overtimes_int,f->cosine_rolloff_factor_dbl,side.fft_block_length_int/2*k,0);
		}


		#ifdef _FILTEROUT
		fwrite(&((fftwf_complex*)side.in)[0][0],sizeof(float)
				,pow(2,block_exp_int),test_Fp);
		#endif


		
		#ifdef _DEBUGMAKEALLFILTERS
			printf("eliminate_mainlobe_int[%d]\n",eliminate_mainlobe_int);//test
			getch();
		#endif


		#ifndef _DEBUGMAKEALLFILTERS
		fftexe(&side);
		#endif
				
		if(	strcmp(side.transform_kind_cp,DFT) ){ // REAL2REAL
			// REAL2REAL
			for(int i=0;i<side.fft_block_length_int;i++){
			#ifndef _DEBUGMAKEALLFILTERS
				f->side_filter_r2r[k][i]=((double*)main.out)[i];
			#endif
			#ifdef _DEBUGMAKEALLFILTERS
				f->side_filter_r2r[k][i]=((double*)main.in)[i];
			#endif
			}
		}else{ //DFT
			int j=0;

			#ifndef _DEBUGMAKEALLFILTERS
			for(int i=0;i<side.fft_block_length_int/2+1;i++){
				f->side_filter_r2r[k][j++]=((fftwf_complex*)side.out)[i][0];
			}
			for(int i=side.fft_block_length_int/2-1;i>0;i--){
				f->side_filter_r2r[k][j++]=((fftwf_complex*)side.out)[i][1];
			}
			if(j!=side.fft_block_length_int) printf("makeallfilter error \n");
			#endif	

			#ifdef _DEBUGMAKEALLFILTERS
			for(int i=0;i<side.fft_block_length_int;i++){
				f->side_filter_r2r[k][j++]=((fftwf_complex*)side.in)[i][0];
			}
			if(j!=side.fft_block_length_int) printf("makeallfilter error \n");
			#endif
		}
	}
	
	#ifdef _DEBUGMAKEALLFILTERS
		printf("fftfree start\n");
	#endif
	fftfree(&side);
	#ifdef _DEBUGMAKEALLFILTERS
		printf("fftfree end\n");
	#endif
	

/*	#ifdef _DEBUGMAKEALLFILTERS
	for(int j=0;j<(f->div_int-1)/2;j++){ //2
		for(int i=0;i<(int)pow(2,f->filter_length_exp_int)/(f->div_int-1);i++){ //16
			printf("side_filter_r2r[%d][%d]=",j,i);
			printf("%f\n",f->side_filter_r2r[j][i]);
		}
		printf("\n");
	}
	#endif
*/
		#ifdef _FILTEROUT
		fclose(test_Fp);		
		#endif

	return 1;
}


void freeallfilters(Filter* f)
{
	free(f->main_filter_r2r);
	
	free(f->side_filter_r2r[0]);
	free(f->side_filter_r2r);
}
