/* FUSE(FastUpSamplingEngin) was written by choi on Nov.23,2004.
 *                                   (this version: Jan.7,2007)
 * You can contact them at http://sak2-2.tok2.com/home/choi/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include <stdio.h>
#ifndef unix
#include <conio.h>
#endif
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "convolution.h"
#include "makefilter.h"
#include "define.h"

//#define _DEBUGMAKEFILTER

int makefilter(Fftv* a
	,int overtimes_int
	,double cosine_rolloff_factor_dbl
	,int distance_from_center_int
	,int eliminate_mainlobe_int)
{
	//makefilter must be REAL2REAL
//	if(	!strcmp(a->transform_kind_cp,DFT) ) return false;

	long double *filter_sin_precalc_ldblp;
	if( (filter_sin_precalc_ldblp = (long double *)malloc((overtimes_int*2)*(sizeof(long double)))) 
		== NULL) {printf("malloc error\n");exit(1);}

  	//google pi
  	long double pai_ldbl=3.14159265358979323846264338327950288419716939937510582097494459230781640628620899862803482534211706798214808651328230664709384460955058223172535940812848111745028410270193852110555964462294895493038196;

	//precalc sin
  	filter_sin_precalc_ldblp[0]          =0;
  	filter_sin_precalc_ldblp[overtimes_int]  =0;
//  	filter_sin_precalc_ldblp[overtimes_int*2]=0;
	for(int loopi_int=1;loopi_int<overtimes_int;loopi_int++){
    	filter_sin_precalc_ldblp[loopi_int              ]
    		= sinl(pai_ldbl*(long double)loopi_int/(long double)overtimes_int);
    	filter_sin_precalc_ldblp[loopi_int+overtimes_int]
    		=-sinl(pai_ldbl*(long double)loopi_int/(long double)overtimes_int);
  	}

	long double distance_from_center_ldbl
		=(long double)distance_from_center_int;

	#ifdef _DEBUGMAKEFILTER
	printf("make before k");//test

	printf("fft_block_length_int %d\n",a->fft_block_length_int);//test
	printf("fft_block_length_int %d\n",eliminate_mainlobe_int);//test
	#endif

	//clear data overlap area
	for(int k=(a->fft_block_length_int)/2+1;
			k<(a->fft_block_length_int);k++){

		if(	strcmp(a->transform_kind_cp,DFT) ){ // REAL2REAL

			switch(a->precision_int){
				case FLOAT_PRECISION:
					((float*)a->in)[k]=0;
				break;
				case DOUBLE_PRECISION:
					((double*)a->in)[k]=0;
				break;
				case LONG_DOUBLE_PRECISION:
					((long double*)a->in)[k]=0;
				break;
				return false;
			}

		}else{									// DFT

			switch(a->precision_int){
				case FLOAT_PRECISION:
					((fftwf_complex*)a->in)[k][0]=0;
					((fftwf_complex*)a->in)[k][1]=0;
				break;
				case DOUBLE_PRECISION:
					((fftw_complex*)a->in)[k][0]=0;
					((fftw_complex*)a->in)[k][1]=0;
				break;
				case LONG_DOUBLE_PRECISION:
					((fftwl_complex*)a->in)[k][0]=0;
					((fftwl_complex*)a->in)[k][1]=0;
				break;
				return false;
			}

		}
			

		#ifdef _DEBUGMAKEFILTER
		printf("clear data overlap area [%d]/[%d] \n",k,(a->fft_block_length_int));//test
		#endif

	}
	//eliminate mainlobe
	for(int k=0;k<eliminate_mainlobe_int/2+1;k++){

//		a->in[k]=0;
		if(	strcmp(a->transform_kind_cp,DFT) ){ // REAL2REAL

			switch(a->precision_int){
				case FLOAT_PRECISION:
					((float*)a->in)[k]=0;
				break;
				case DOUBLE_PRECISION:
					((double*)a->in)[k]=0;
				break;
				case LONG_DOUBLE_PRECISION:
					((long double*)a->in)[k]=0;
				break;
				return false;
			}

		}else{									// DFT

			switch(a->precision_int){
				case FLOAT_PRECISION:
					((fftwf_complex*)a->in)[k][0]=0;
					((fftwf_complex*)a->in)[k][1]=0;
				break;
				case DOUBLE_PRECISION:
					((fftw_complex*)a->in)[k][0]=0;
					((fftw_complex*)a->in)[k][1]=0;
				break;
				case LONG_DOUBLE_PRECISION:
					((fftwl_complex*)a->in)[k][0]=0;
					((fftwl_complex*)a->in)[k][1]=0;
				break;
				return false;
			}

		}

		#ifdef _DEBUGMAKEFILTER
		printf("eliminate mainlobe [%d]/[%d] \n",k,(a->fft_block_length_int));//test
		#endif
	}


	////////////////////////make filter data
	int i=0;
	
			//center of impulse
			if(eliminate_mainlobe_int==0){

				distance_from_center_ldbl++;
				if(distance_from_center_int==0){

//					a->in[i++]=0.5;
					if(	strcmp(a->transform_kind_cp,DFT) ){ // REAL2REAL

						switch(a->precision_int){
							case FLOAT_PRECISION:
								((float*)a->in)[i++]=0.5;
							break;
							case DOUBLE_PRECISION:
								((double*)a->in)[i++]=0.5;
							break;
							case LONG_DOUBLE_PRECISION:
								((long double*)a->in)[i++]=0.5;
							break;
							return false;
						}

					}else{									// DFT

						switch(a->precision_int){
							case FLOAT_PRECISION:
								((fftwf_complex*)a->in)[i][0]=0.5;
								((fftwf_complex*)a->in)[i++][1]=0;
							break;
							case DOUBLE_PRECISION:
								((fftw_complex*)a->in)[i][0]=0.5;
								((fftw_complex*)a->in)[i++][1]=0;
							break;
							case LONG_DOUBLE_PRECISION:
								((fftwl_complex*)a->in)[i][0]=0.5;
								((fftwl_complex*)a->in)[i++][1]=0;
							break;
							return false;
						}

					}
					
					#ifdef _DEBUGMAKEFILTER
					printf("center of impulse 0.5[%d]/[%d] \n",i-1,(a->fft_block_length_int));//test
					#endif
					
				}else{
//					a->in[i++]=0;
					if(	strcmp(a->transform_kind_cp,DFT) ){ // REAL2REAL

						switch(a->precision_int){
							case FLOAT_PRECISION:
								((float*)a->in)[i++]=0;
							break;
							case DOUBLE_PRECISION:
								((double*)a->in)[i++]=0;
							break;
							case LONG_DOUBLE_PRECISION:
								((long double*)a->in)[i++]=0;
							break;
							return false;
						}

					}else{									// DFT

						switch(a->precision_int){
							case FLOAT_PRECISION:
								((fftwf_complex*)a->in)[i][0]=0;
								((fftwf_complex*)a->in)[i++][1]=0;
							break;
							case DOUBLE_PRECISION:
								((fftw_complex*)a->in)[i][0]=0;
								((fftw_complex*)a->in)[i++][1]=0;
							break;
							case LONG_DOUBLE_PRECISION:
								((fftwl_complex*)a->in)[i][0]=0;
								((fftwl_complex*)a->in)[i++][1]=0;
							break;
							return false;
						}

					}

					#ifdef _DEBUGMAKEFILTER
					printf("clear a overlaped tap[%d]/[%d] \n",i-1,(a->fft_block_length_int));//test
					#endif
				}

			}else{
				distance_from_center_ldbl+=(long double)(eliminate_mainlobe_int/2+1);
				i+=(eliminate_mainlobe_int/2+1);
			}

			//body
			int j=(int)distance_from_center_ldbl%(overtimes_int*2);
			do{

				//sinc x window function
/*
 * 				((long double*)a->in)[i++]
						=filter_sin_precalc_ldblp[j++]
						*(long double)overtimes_int
						/(pai_ldbl*distance_from_center_ldbl)
					//cosine roll off
						*cosl(pai_ldbl*((long double)cosine_rolloff_factor_dbl *(pai_ldbl*distance_from_center_ldbl)/(long double)overtimes_int))
							/(1-4*(  (long double)cosine_rolloff_factor_dbl *(pai_ldbl*distance_from_center_ldbl)/(long double)overtimes_int )
							*(       (long double)cosine_rolloff_factor_dbl *(pai_ldbl*distance_from_center_ldbl)/(long double)overtimes_int )
						);
*/						
//					a->in[i++]=0.5;
					if(	strcmp(a->transform_kind_cp,DFT) ){ // REAL2REAL

						switch(a->precision_int){
							case FLOAT_PRECISION:
								((float*)a->in)[i++]
									=(float)(filter_sin_precalc_ldblp[j++]
									*(long double)overtimes_int
									/(pai_ldbl*distance_from_center_ldbl)
								//cosine roll off
									*cosl(pai_ldbl*((long double)cosine_rolloff_factor_dbl *(pai_ldbl*distance_from_center_ldbl)/(long double)overtimes_int))
										/(1-4*(  (long double)cosine_rolloff_factor_dbl *(pai_ldbl*distance_from_center_ldbl)/(long double)overtimes_int )
										*(       (long double)cosine_rolloff_factor_dbl *(pai_ldbl*distance_from_center_ldbl)/(long double)overtimes_int )
									));
							break;
							case DOUBLE_PRECISION:
								((double*)a->in)[i++]
									=(double)(filter_sin_precalc_ldblp[j++]
									*(long double)overtimes_int
									/(pai_ldbl*distance_from_center_ldbl)
								//cosine roll off
									*cosl(pai_ldbl*((long double)cosine_rolloff_factor_dbl *(pai_ldbl*distance_from_center_ldbl)/(long double)overtimes_int))
										/(1-4*(  (long double)cosine_rolloff_factor_dbl *(pai_ldbl*distance_from_center_ldbl)/(long double)overtimes_int )
										*(       (long double)cosine_rolloff_factor_dbl *(pai_ldbl*distance_from_center_ldbl)/(long double)overtimes_int )
									));
							break;
							case LONG_DOUBLE_PRECISION:
								((long double*)a->in)[i++]
									=(filter_sin_precalc_ldblp[j++]
									*(long double)overtimes_int
									/(pai_ldbl*distance_from_center_ldbl)
								//cosine roll off
									*cosl(pai_ldbl*((long double)cosine_rolloff_factor_dbl *(pai_ldbl*distance_from_center_ldbl)/(long double)overtimes_int))
										/(1-4*(  (long double)cosine_rolloff_factor_dbl *(pai_ldbl*distance_from_center_ldbl)/(long double)overtimes_int )
										*(       (long double)cosine_rolloff_factor_dbl *(pai_ldbl*distance_from_center_ldbl)/(long double)overtimes_int )
									));
							break;
							return false;
						}

					}else{									// DFT

						switch(a->precision_int){
							case FLOAT_PRECISION:
								((fftwf_complex*)a->in)[i][0]
									=(float)(filter_sin_precalc_ldblp[j++]
									*(long double)overtimes_int
									/(pai_ldbl*distance_from_center_ldbl)
								//cosine roll off
									*cosl(pai_ldbl*((long double)cosine_rolloff_factor_dbl *(pai_ldbl*distance_from_center_ldbl)/(long double)overtimes_int))
										/(1-4*(  (long double)cosine_rolloff_factor_dbl *(pai_ldbl*distance_from_center_ldbl)/(long double)overtimes_int )
										*(       (long double)cosine_rolloff_factor_dbl *(pai_ldbl*distance_from_center_ldbl)/(long double)overtimes_int )
									));
								((fftwf_complex*)a->in)[i++][1]=0;
							break;
							case DOUBLE_PRECISION:
								((fftw_complex*)a->in)[i][0]
									=(double)(filter_sin_precalc_ldblp[j++]
									*(long double)overtimes_int
									/(pai_ldbl*distance_from_center_ldbl)
								//cosine roll off
									*cosl(pai_ldbl*((long double)cosine_rolloff_factor_dbl *(pai_ldbl*distance_from_center_ldbl)/(long double)overtimes_int))
										/(1-4*(  (long double)cosine_rolloff_factor_dbl *(pai_ldbl*distance_from_center_ldbl)/(long double)overtimes_int )
										*(       (long double)cosine_rolloff_factor_dbl *(pai_ldbl*distance_from_center_ldbl)/(long double)overtimes_int )
									));
								((fftw_complex*)a->in)[i++][1]=0;
							break;
							case LONG_DOUBLE_PRECISION:
								((fftwl_complex*)a->in)[i][0]
									=(filter_sin_precalc_ldblp[j++]
									*(long double)overtimes_int
									/(pai_ldbl*distance_from_center_ldbl)
								//cosine roll off
									*cosl(pai_ldbl*((long double)cosine_rolloff_factor_dbl *(pai_ldbl*distance_from_center_ldbl)/(long double)overtimes_int))
										/(1-4*(  (long double)cosine_rolloff_factor_dbl *(pai_ldbl*distance_from_center_ldbl)/(long double)overtimes_int )
										*(       (long double)cosine_rolloff_factor_dbl *(pai_ldbl*distance_from_center_ldbl)/(long double)overtimes_int )
									));
								((fftwl_complex*)a->in)[i++][1]=0;
							break;
							return false;
						}

					}
						
				distance_from_center_ldbl++;
				if(j>=overtimes_int*2) j=0;

				#ifdef _DEBUGMAKEFILTER
				printf("body [%d]/[%d] \n",i-1,(a->fft_block_length_int));//test
				#endif

			}while(i < (a->fft_block_length_int)/2+1 );
		
	free(filter_sin_precalc_ldblp);
	return true;
}

