/* FUSE(FastUpSamplingEngin) was written by choi on Nov.23,2004.
 *                                   (this version: Jan.7,2007)
 * You can contact them at http://sak2-2.tok2.com/home/choi/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include <stdio.h>
#ifndef unix
#include <conio.h>
#endif
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "define.h"


#include "normalize_soundfile.h"
#include "soundfile.h"
#include "mt19937ar.h"
//normalize_soundfile("d:\\c.raw","c:\\d24.raw",out_wave_absmax_dbl,OVERX,OVERXF,TEXP,(int)pow(2,DIVEXP)+1,1);//x4 t25 tdiv9 opt1

//#define TPDFVALUE	1024
#define OUTPUT_BITS_PER_SAMPLE	24
//#define TPDF_PEAK_X4_24BITLSB   4096
#define OUTPUT_CHANNELS	2
#define WAV_HEADER_SIZE_DEFAULT 44

int normalize_soundfile(
	char* converted_filename_cp
	,char* normalized_filename_cp
	,char* original_filename_cp
	,double out_wave_absmax_dbl
	,int overtimes_int
	,int fovertimes_int
	,int tpdf_peak_24bitLSB_int
	,double nyquist_dither_peak_24bitLSB_dbl
	,double random_dither_peak_24bitLSB_dbl
	)
{
	FILE* converted_Fp;
	if ((converted_Fp = fopen(converted_filename_cp,"rb")) == NULL) {printf("Cannot open. \n");return(-1);}

	FILE* normalized_Fp;
	if ((normalized_Fp = fopen(normalized_filename_cp,"wb")) == NULL) {printf("Cannot open. \n");return(-1);}
	
	FILE* original_Fp;
	WaveChunk original_wave_file_WC  ={"    ",0,"    ","    ",0,0,0,0,0,0,0,"    ",0,0};
	WaveChunk normalized_wave_file_WC  ={"    ",0,"    ","    ",0,0,0,0,0,0,0,"    ",0,0};
	if ((original_Fp = fopen(original_filename_cp,"rb")) == NULL) {printf("%s\n",original_filename_cp);return(-1);}
	read_wav_chunk(original_Fp,&original_wave_file_WC,false);

	strcpy(normalized_wave_file_WC.RIFFchunkID_chr, original_wave_file_WC.RIFFchunkID_chr);
  	strcpy(normalized_wave_file_WC.RIFFformType_chr,original_wave_file_WC.RIFFformType_chr);
  	strcpy(normalized_wave_file_WC.Fmt_chunkID_chr, original_wave_file_WC.Fmt_chunkID_chr);
//  normalized_wave_file_WC.Fmt_chunkSize_int      =original_wave_file_WC.Fmt_chunkSize_int; //v0.1.3
  	normalized_wave_file_WC.Fmt_chunkSize_int      =16;                                        //v0.1.4
  	normalized_wave_file_WC.Fmt_wFormatTag_sht     =original_wave_file_WC.Fmt_wFormatTag_sht;
  	normalized_wave_file_WC.Fmt_nChannels_usht     =original_wave_file_WC.Fmt_nChannels_usht;
  	normalized_wave_file_WC.Fmt_nSamplesPerSec_ul  =original_wave_file_WC.Fmt_nSamplesPerSec_ul*overtimes_int;
  	normalized_wave_file_WC.Fmt_nAvgBytesPerSec_ul
   		=original_wave_file_WC.Fmt_nAvgBytesPerSec_ul*(OUTPUT_BITS_PER_SAMPLE * overtimes_int / original_wave_file_WC.Fmt_wBitsPerSample_usht);
  	normalized_wave_file_WC.Fmt_nBlockAlign_usht
    	=(unsigned short)((int)original_wave_file_WC.Fmt_nBlockAlign_usht
      	*(int)OUTPUT_BITS_PER_SAMPLE/(int)original_wave_file_WC.Fmt_wBitsPerSample_usht
      	*(int)OUTPUT_CHANNELS/(int)original_wave_file_WC.Fmt_nChannels_usht);
  	normalized_wave_file_WC.Fmt_wBitsPerSample_usht=OUTPUT_BITS_PER_SAMPLE;

  	strcpy(normalized_wave_file_WC.Data_chunkID_chr,original_wave_file_WC.Data_chunkID_chr);
  	normalized_wave_file_WC.Data_chunkSize_ul
    	=(unsigned long)(
    		(
    		(unsigned long long)original_wave_file_WC.Data_chunkSize_ul
    		*(unsigned long long)overtimes_int
    		)
    		*(unsigned long long)normalized_wave_file_WC.Fmt_nBlockAlign_usht
    		/(unsigned long long)original_wave_file_WC.Fmt_nBlockAlign_usht
    	);
  	normalized_wave_file_WC.header_size_int=WAV_HEADER_SIZE_DEFAULT;
  	normalized_wave_file_WC.RIFFchunkSize_ul=normalized_wave_file_WC.Data_chunkSize_ul+normalized_wave_file_WC.header_size_int-8;
	
	write_wav_chunk(normalized_Fp,&normalized_wave_file_WC,overtimes_int/fovertimes_int,true);

	double readsample_dbl[2];
	int readsample_int[2];
	int out_wave_17to24SB_int;
	int out_wave_MSBto16SB_int;
	
	init_genrand(1234);
	//    int dither_2delayed_int=rand()-0x3fff;
    double dither_2delayed_dbl=((double)genrand_int32()-0x7fffffff)/pow(16,8);//}0.5 RPDF
    double dither_delayed_dbl =((double)genrand_int32()-0x7fffffff)/pow(16,8);//}0.5 RPDF
    double dither_dbl         =((double)genrand_int32()-0x7fffffff)/pow(16,8);//}0.5 RPDF

	double tpdf_peak_24bitLSB_dbl=tpdf_peak_24bitLSB_int;

    double nyquist_dither_dbl     =nyquist_dither_peak_24bitLSB_dbl;
	
	while(1){
		if(fread(&readsample_dbl[0],sizeof(double),2,converted_Fp)<2){
			fclose(converted_Fp);
			fclose(normalized_Fp);
			fclose(original_Fp);
			return 1;
		};
		
		dither_2delayed_dbl=dither_delayed_dbl;
      	dither_delayed_dbl=dither_dbl;
//      	dither_dbl=((double)genrand_int32()-0x7fffffff)/pow(16,8);//}0.5 RPDF v020
      	dither_dbl=((double)genrand_int32()-0x7fffffff)/pow(16,8)*2*random_dither_peak_24bitLSB_dbl;//}1RPDF
		
	//	printf("%le\n",dither_dbl);
		
//		readsample_int[0]=(int)round(dither_dbl*2*TPDFVALUE*overtimes_int);
//		readsample_int[1]=(int)round(dither_dbl*2*TPDFVALUE*overtimes_int);

/*		readsample_int[0]=(int)round(readsample_dbl[0]
			/(out_wave_absmax_dbl+out_wave_absmax_dbl/(pow(2,23)-1)*TPDFVALUE*overtimes_int)
			*pow(2,23)+dither_dbl*2*TPDFVALUE*overtimes_int);
		readsample_int[1]=(int)round(readsample_dbl[1]
			/(out_wave_absmax_dbl+out_wave_absmax_dbl/(pow(2,23)-1)*TPDFVALUE*overtimes_int)
			*pow(2,23)+dither_dbl*2*TPDFVALUE*overtimes_int);

		readsample_int[0]=(int)round(readsample_dbl[0]
			/(out_wave_absmax_dbl+out_wave_absmax_dbl/(pow(2,23)-1)*TPDFVALUE*overtimes_int)*(pow(2,23)-1));
		readsample_int[1]=(int)round(readsample_dbl[1]
			/(out_wave_absmax_dbl+out_wave_absmax_dbl/(pow(2,23)-1)*TPDFVALUE*overtimes_int)*(pow(2,23)-1));
*/		
		readsample_int[0]=(int)round(
          ( readsample_dbl[0]                         //31bit int
            /out_wave_absmax_dbl
            *( 1-(tpdf_peak_24bitLSB_dbl+nyquist_dither_peak_24bitLSB_dbl)*pow(2,1-OUTPUT_BITS_PER_SAMPLE) )
            
          *(pow(2,(OUTPUT_BITS_PER_SAMPLE-1))-1)            //}23bit(=24bitPCM)
			)
          +(dither_dbl-dither_2delayed_dbl)*tpdf_peak_24bitLSB_dbl //+TPDF dither
          +nyquist_dither_dbl+dither_dbl
          );
		
		readsample_int[1]=(int)round(
          ( readsample_dbl[1]                         //31bit int
            /out_wave_absmax_dbl
            *( 1-(tpdf_peak_24bitLSB_dbl+nyquist_dither_peak_24bitLSB_dbl)*pow(2,1-OUTPUT_BITS_PER_SAMPLE) )
            
          *(pow(2,(OUTPUT_BITS_PER_SAMPLE-1))-1)            //}23bit(=24bitPCM)
           )

          +(dither_dbl-dither_2delayed_dbl)*tpdf_peak_24bitLSB_dbl //+TPDF dither
          +nyquist_dither_dbl+dither_dbl
           );
          
          nyquist_dither_dbl*=-1;

	  out_wave_17to24SB_int=(readsample_int[0] & 0xFF);
      out_wave_MSBto16SB_int=readsample_int[0]>>8;
      fputc(out_wave_17to24SB_int,normalized_Fp);
      fwrite(&out_wave_MSBto16SB_int,sizeof(short),1,normalized_Fp);

	  out_wave_17to24SB_int=(readsample_int[1] & 0xFF);
      out_wave_MSBto16SB_int=readsample_int[1]>>8;
      fputc(out_wave_17to24SB_int,normalized_Fp);
      fwrite(&out_wave_MSBto16SB_int,sizeof(short),1,normalized_Fp);
		
	//	fwrite(&readsample_int[0],sizeof(int),2,normalized_Fp);



	}
	return 1;
}

