/* FUSE(FastUpSamplingEngin) was written by choi on Nov.23,2004.
 *                                   (this version: Jan.7,2007)
 * You can contact them at http://sak2-2.tok2.com/home/choi/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include <stdio.h>
#include <stdint.h>
//#include <conio.h>
#include <stdlib.h>
#include <string.h>

#include "soundfile.h"

int read_wav_chunk(FILE* filename_Fp,WaveChunk* wav_chunk_WC,int p)
{
  if (!feof(filename_Fp)) {fgets(wav_chunk_WC->RIFFchunkID_chr, 5, filename_Fp); //RIFFchunkID_chr 4byte="RIFF"
    if(p){printf("1 RIFF                         :%s\n", wav_chunk_WC->RIFFchunkID_chr);}}
  if (!feof(filename_Fp)) {fread(&wav_chunk_WC->RIFFchunkSize_ul,sizeof(uint32_t),1,filename_Fp);//@/RIFFchunkSize_ul 4byte(int)= filesize-8
    if(p){printf("2 Filesize-8 (byte)            :%lu\n",wav_chunk_WC->RIFFchunkSize_ul);}}
  if (!feof(filename_Fp)) {fgets(wav_chunk_WC->RIFFformType_chr, 5, filename_Fp); //RIFFformType_chr 4byte="WAVE"
    if(p){printf("3 WAVE                         :%s\n",wav_chunk_WC->RIFFformType_chr);}}
  if (!feof(filename_Fp)) {fgets(wav_chunk_WC->Fmt_chunkID_chr, 5, filename_Fp);//  Fmt_chunkID_chr 4byte"fmt "
    if(p){printf("4 fmt                          :%s\n",wav_chunk_WC->Fmt_chunkID_chr);}}
  if (!feof(filename_Fp)) {fread(&wav_chunk_WC->Fmt_chunkSize_int,sizeof(int) ,1,filename_Fp);//Fmt_chunkSize_int 4byte(int) = 0x10(WAVE)
    if(p){printf("5 chunkSize(wave eq 16)        :%d\n",wav_chunk_WC->Fmt_chunkSize_int);}}

  if(p){printf("6 fmt sub chunk\n");}
  if (!feof(filename_Fp)) {fread(&wav_chunk_WC->Fmt_wFormatTag_sht,sizeof(short) ,1,filename_Fp);//Fmt_wFormatTag_sht 2byte(short)=WAVE_FORMAT_PCM (1)
    if(p){printf("   Fmt_wFormatTag_sht          :%d\n",wav_chunk_WC->Fmt_wFormatTag_sht);}}
  if (!feof(filename_Fp)) {fread(&wav_chunk_WC->Fmt_nChannels_usht,sizeof(short) ,1,filename_Fp);//@/Fmt_nChannels_usht 2byte(short)
    if(p){printf("   Fmt_nChannels_usht          :%d\n",wav_chunk_WC->Fmt_nChannels_usht);}}
  if (!feof(filename_Fp)) {fread(&wav_chunk_WC->Fmt_nSamplesPerSec_ul,sizeof(int) ,1,filename_Fp);//@/Fmt_nSamplesPerSec_ul 4byte(int)
    if(p){printf("   Fmt_nSamplesPerSec_ul(Hz)   :%lu\n",wav_chunk_WC->Fmt_nSamplesPerSec_ul);}}
  if (!feof(filename_Fp)) {fread(&wav_chunk_WC->Fmt_nAvgBytesPerSec_ul,sizeof(int) ,1,filename_Fp);//@/Fmt_nAvgBytesPerSec_ul 4byte(int)
    if(p){printf("   Fmt_nAvgBytesPerSec_ul(bps) :%lu\n",wav_chunk_WC->Fmt_nAvgBytesPerSec_ul);}}
  if (!feof(filename_Fp)) {fread(&wav_chunk_WC->Fmt_nBlockAlign_usht,sizeof(short) ,1,filename_Fp);//@/Fmt_nBlockAlign_usht 2byte(short)
    if(p){printf("   Fmt_nBlockAlign_usht(byte)  :%d\n",wav_chunk_WC->Fmt_nBlockAlign_usht);}}
  if (!feof(filename_Fp)) {fread(&wav_chunk_WC->Fmt_wBitsPerSample_usht,sizeof(short) ,1,filename_Fp);//@/Fmt_wBitsPerSample_usht 2byte(short)
    if(p){printf("   Fmt_wBitsPerSample_usht(bit):%d\n",wav_chunk_WC->Fmt_wBitsPerSample_usht);}}

  //Data_chunkID_chr 4byte="data"
  if (!feof(filename_Fp)) {
    wav_chunk_WC->header_size_int=WAV_HEADER_SIZE_DEFAULT-1;
    char tmp_chunkID[]="data";

//    printf("header_size_int:%d\n",wav_chunk_WC->header_size_int);

    wav_chunk_WC->header_size_int+=4;
    fgets(tmp_chunkID, 5, filename_Fp); // (5 - 1)ǂ܂

//    printf("header_size_int:%d\n",wav_chunk_WC->header_size_int);
//    printf("first mojiretsu:%s getch\n",tmp_chunkID);getch();

    while(strcmp(tmp_chunkID,"data\0")!=0){
      tmp_chunkID[0]=tmp_chunkID[1];
      tmp_chunkID[1]=tmp_chunkID[2];
      tmp_chunkID[2]=tmp_chunkID[3];

      wav_chunk_WC->header_size_int++;
      fgets(&tmp_chunkID[3], 2, filename_Fp); // (2 - 1)ǂ܂

//      printf("mojiretsu:%s\n",tmp_chunkID);
    }

//    printf("header_size_int:%d\n",wav_chunk_WC->header_size_int);
//    printf("mojiretsu fin:%s\n",tmp_chunkID);
    strcpy(wav_chunk_WC->Data_chunkID_chr,"data");
//    printf("moji fin:%s\n",wav_chunk_WC->Data_chunkID_chr);

    if(p)printf("7 data                         :%s\n",wav_chunk_WC->Data_chunkID_chr);
  }
  //@/Data_chunkSize_ul 4byte(unsinged long)
  if (!feof(filename_Fp)) {fread(&wav_chunk_WC->Data_chunkSize_ul,sizeof(unsigned int) ,1,filename_Fp);
    if(p){printf("8 Data_chunkSize_ul(byte)      :%lu\n",wav_chunk_WC->Data_chunkSize_ul);}}

  return 1;
}



int write_wav_chunk(FILE* filename_Fp,WaveChunk* wav_chunk_WC,int forced_overtimes_ratio_int,int p)
{
  unsigned long tmp_nSamplesPerSec_ul,tmp_nAvgBytesPerSec_ul;
  tmp_nSamplesPerSec_ul = wav_chunk_WC->Fmt_nSamplesPerSec_ul/forced_overtimes_ratio_int;
  tmp_nAvgBytesPerSec_ul= wav_chunk_WC->Fmt_nAvgBytesPerSec_ul/forced_overtimes_ratio_int;

  fputs(wav_chunk_WC->RIFFchunkID_chr,filename_Fp);
    if(p){printf("1 RIFF                         :%s\n", wav_chunk_WC->RIFFchunkID_chr);}
  fwrite(&wav_chunk_WC->RIFFchunkSize_ul,sizeof(unsigned int),1,filename_Fp);
    if(p){printf("2 Filesize-8 (byte)            :%lu\n", wav_chunk_WC->RIFFchunkSize_ul);}
  fputs(wav_chunk_WC->RIFFformType_chr,filename_Fp);
    if(p){printf("3 WAVE                         :%s\n", wav_chunk_WC->RIFFformType_chr);}
  fputs(wav_chunk_WC->Fmt_chunkID_chr,filename_Fp);
    if(p){printf("4 fmt                          :%s\n", wav_chunk_WC->Fmt_chunkID_chr);}
  fwrite(&wav_chunk_WC->Fmt_chunkSize_int,sizeof(int),1,filename_Fp);
    if(p){printf("5 chunkSize(wave eq 16)        :%d\n", wav_chunk_WC->Fmt_chunkSize_int);}
  if(p){printf("6 fmt sub chunk\n");}
  fwrite(&wav_chunk_WC->Fmt_wFormatTag_sht,sizeof(short),1,filename_Fp);
    if(p){printf("   Fmt_wFormatTag_sht          :%d\n",wav_chunk_WC->Fmt_wFormatTag_sht);}
  fwrite(&wav_chunk_WC->Fmt_nChannels_usht,sizeof(short),1,filename_Fp);
    if(p){printf("   Fmt_nChannels_usht          :%d\n",wav_chunk_WC->Fmt_nChannels_usht);}

  fwrite(&tmp_nSamplesPerSec_ul,sizeof(int),1,filename_Fp);
//  fwrite(&wav_chunk_WC->Fmt_nSamplesPerSec_ul/forced_overtimes_ratio_int,sizeof(int),1,filename_Fp);
    if(p){printf("   Fmt_nSamplesPerSec_ul(Hz)   :%lu\n",wav_chunk_WC->Fmt_nSamplesPerSec_ul);}

  fwrite(&tmp_nAvgBytesPerSec_ul,sizeof(int),1,filename_Fp);
//  fwrite(&wav_chunk_WC->Fmt_nAvgBytesPerSec_ul/forced_overtimes_ratio_int,sizeof(int),1,filename_Fp);
    if(p){printf("   Fmt_nAvgBytesPerSec_ul(bps) :%lu\n",wav_chunk_WC->Fmt_nAvgBytesPerSec_ul);}

  fwrite(&wav_chunk_WC->Fmt_nBlockAlign_usht,sizeof(short),1,filename_Fp);
    if(p){printf("   Fmt_nBlockAlign_usht(byte)  :%d\n",wav_chunk_WC->Fmt_nBlockAlign_usht);}
  fwrite(&wav_chunk_WC->Fmt_wBitsPerSample_usht,sizeof(short),1,filename_Fp);
    if(p){printf("   Fmt_wBitsPerSample_usht(bit):%d\n",wav_chunk_WC->Fmt_wBitsPerSample_usht);}
  fputs(wav_chunk_WC->Data_chunkID_chr,filename_Fp);
    if(p){printf("7 data                         :%s\n", wav_chunk_WC->Data_chunkID_chr);}
  fwrite(&wav_chunk_WC->Data_chunkSize_ul,sizeof(unsigned int),1,filename_Fp);
    if(p){printf("8 Data_chunkSize_ul(byte)      :%lu\n", wav_chunk_WC->Data_chunkSize_ul);}

  return 1;
}
