/* FUSE(FastUpSamplingEngin) was written by choi on Nov.23,2004.
 *                                   (this version: Jan.7,2007)
 * You can contact them at http://sak2-2.tok2.com/home/choi/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#ifndef unix
#include <conio.h>
#include <io.h>
#endif
#include <time.h>

#include "../soundfile.h"
#include "../fft_soundfile.h"
#include "../ifft_soundfile.h"

#include "../convolution.h"
#include "../define.h"
#include "../makefilter.h"
#ifdef unix
#include <fftw3.h>
#else
#include "../fftw3.h"
#endif

#include "../normalize_soundfile.h"

#define MAINEXP	18
#define TEXP		25

//x4 t26 x8 t27	}3.17min
//x4 t25 x8 t26	}95.11sec
//x4 t24 x8 t25	}47.55sec

//#define DIVEXP		1	//div3
#define DIVEXP		5
//#define DIVEXP		5	//div33
//#define DIVEXP		4	//div17
//#define DIVEXP		3	//div9

//#define FILENAME_BUF_SIZE 512

//#define SUFFIX ".x"
//#define SUF_TPDF ".TPDF"

//#define TPDFVALUE	1024


int main(int argc,char *argv[]){
	if(argc<2){printf("Drug&Drop me your wav file!!\n");exit(1);}
//	if(argc<2){printf("Drug&Drop me your wav file!!\n");getch();exit(1);}

	//default value
	int overtimes_int=OVERTIMES;	// -x
	int forced_overtimes_int=-1;	// -xf
	int tap_exp_int=TEXP;			// -t
	int div_exp_int=-1;	// -div
	int div_int=(int)pow(2,div_exp_int)+1;	// -div
	int tpdf_peak_24bitLSB_int=-1;	// -tpdf
	double nyquist_dither_peak_24bitLSB_dbl=NYQUISTDITHER;//-nd
	double random_dither_peak_24bitLSB_dbl=RANDOMDITHER;//-rd
	
//	int tpdf_peak_24bitLSB_int=TPDFVALUE*overtimes_int;	// -tpdf
	double cosine_rolloff_factor_dbl=-1;//-a
	double	gain_dbl=-1;//-g
	// option
  for(int loopi_option_int=1;loopi_option_int<argc-1;loopi_option_int++){

    if(strcmp(argv[loopi_option_int],"-g")==0){ //gain option  usually 0.7 to 0.99
      if(atof(argv[++loopi_option_int])==0){
        gain_dbl=-1;
      }else{
        gain_dbl=(double)atof(argv[loopi_option_int]);
        //        printf("out_wave_absmax_gain_dbl: %lf\n",(float)out_wave_absmax_gain_dbl);getch();
      }
    }

//    if(strcmp(argv[loopi_option_int],"-o")==0){ //optimize
//      opt_int=atoi(argv[++loopi_option_int]); //-o optimize option; 0:ESTIMATE(default) 1:FFTW_MEASURE 2:FFTW_PATIENT 3:FFTW_EXHAUSTIVE
//    }

    if(strcmp(argv[loopi_option_int],"-t")==0){ //filter tap
      tap_exp_int=atoi(argv[++loopi_option_int]); //-t
	  if(tap_exp_int<21)tap_exp_int=21;
	  if(tap_exp_int>26)tap_exp_int=26;
    }

//    if(strcmp(argv[loopi_option_int],"-b")==0){ //fft_length_int
//      fft_length_int=pow(2,atoi(argv[++loopi_option_int])); //-b
//    }

    if(strcmp(argv[loopi_option_int],"-div2")==0){ //OVERTIMES
      div_exp_int=atoi(argv[++loopi_option_int]); //-x 2 or 4 or 8
      div_int=(int)pow(2,div_exp_int)+1; //-x 2 or 4 or 8
    }

    if(strcmp(argv[loopi_option_int],"-x")==0){ //OVERTIMES
      overtimes_int=atoi(argv[++loopi_option_int]); //-x 2 or 4 or 8
    }

    if(strcmp(argv[loopi_option_int],"-xf")==0){ //OVERTIMES
      forced_overtimes_int=atoi(argv[++loopi_option_int]);
    }

    if(strcmp(argv[loopi_option_int],"-a")==0){ //cosine roll off
      cosine_rolloff_factor_dbl=(double)atof(argv[++loopi_option_int]); //
    }

    if(strcmp(argv[loopi_option_int],"-nd")==0){ //Nyquist dither
      nyquist_dither_peak_24bitLSB_dbl=(double)atof(argv[++loopi_option_int]); //
    }

    if(strcmp(argv[loopi_option_int],"-rd")==0){ //Nyquist dither
      random_dither_peak_24bitLSB_dbl=(double)atof(argv[++loopi_option_int]); //
    }

    if((strcmp(argv[loopi_option_int],"-tpdf")==0)||
       (strcmp(argv[loopi_option_int],"-TPDF")==0)  ){
      tpdf_peak_24bitLSB_int=atoi(argv[++loopi_option_int]);//dither peak level(24bit)
    }

//    if(strcmp(argv[loopi_option_int],"-fo")==0){ //output filter_double.raw
//      output_filter_FLAG_int=1;
//    }

//    if(strcmp(argv[loopi_option_int],"-ms")==0){ //SaveMemory option(select FFT routine)
//      routine_FLAG_cp="r2r";
//    }

//    if(strcmp(argv[loopi_option_int],"-ch")==0){ //Cut Head option(n samples)
//      fft_filter_head_length_int=atoi(argv[++loopi_option_int]);
//    }
//    if(strcmp(argv[loopi_option_int],"-ct")==0){ //Cut Tail option(n samples)
//      fft_filter_tail_length_int=atoi(argv[++loopi_option_int]);
//    }
/*    if(strcmp(argv[loopi_option_int],"-pre")==0){ //
      preserve_input_FLAG_int=1;
    }
*/
//    if(strcmp(argv[loopi_option_int],"-nrmcf")==0){
//      convertedfile_remove_FLAG_int=1;//do not remove converted raw file
//    }

//    if(strcmp(argv[loopi_option_int],"-rmlog")==0){
//      logfile_remove_FLAG_int=0;//remove log file
//    }

/*
    if(strcmp(argv[loopi_option_int],"-d")==0){ //divide
      loopi_option_int++;
      divide_int=(argc-1)-loopi_option_int;

      for(loopj_int=0;loopj_int<divide_int;loopj_int++){
        divide_point_ull[loopj_int]=(double)atof(argv[loopi_option_int++])*((double)original_wave_file_WC.Fmt_nSamplesPerSec_ul)*overtimes_int;//  *176.4k or *192k
      }
      divide_point_ull[divide_int]=0;
    }
*/

    /*
    if(strcmp(argv[loopi_option_int],"-f")==0){ //read filter from file
      strcat(filter_filename_cp,argv[++loopi_option_int]);
    }
     */

  }//for(loopi_option_int=1;loopi_option_int<argc-1;loopi_option_int++){
	
	
	if(cosine_rolloff_factor_dbl<0){cosine_rolloff_factor_dbl=ALPHA_DEFAULT/pow(2,tap_exp_int)/2;}

	if(forced_overtimes_int<0)forced_overtimes_int=overtimes_int;

	if(div_exp_int<0){div_exp_int=DIVEXP-(25-tap_exp_int);div_int=(int)pow(2,div_exp_int)+1;}
//	printf("div_exp_int:%d ",div_exp_int);getch();

	char  overtimes_cp[]="0123456789";
  	sprintf(overtimes_cp,"%d",overtimes_int);

	char tap_exp_cp[]="0123456789";
  	sprintf(tap_exp_cp,"%d",tap_exp_int);

	char div_exp_cp[]="0123456789";
  	sprintf(div_exp_cp,"%d",div_exp_int);

	char nyquist_dither_peak_24bitLSB_cp[]="01234567890123456789";
	if(nyquist_dither_peak_24bitLSB_dbl>0){
  		sprintf( nyquist_dither_peak_24bitLSB_cp , "%lg" , nyquist_dither_peak_24bitLSB_dbl);
	}
	char random_dither_peak_24bitLSB_dbl_cp[]="01234567890123456789";
	if(random_dither_peak_24bitLSB_dbl>0){
  		sprintf( random_dither_peak_24bitLSB_dbl_cp , "%lg" , random_dither_peak_24bitLSB_dbl);
	}
	
	
	if(tpdf_peak_24bitLSB_int<0)	tpdf_peak_24bitLSB_int=TPDFVALUE*overtimes_int;
  	char  tpdf_peaklevel_24LSB_cp[]="0123456789";
  	sprintf(tpdf_peaklevel_24LSB_cp,"%d",tpdf_peak_24bitLSB_int);


  	char *ffted_filename_cp;ffted_filename_cp= (char *)malloc(FILENAME_BUF_SIZE);if(ffted_filename_cp == NULL) { printf("cannot allocate memory.\n"); exit(1);}
  	char *converted_filename_cp;converted_filename_cp= (char *)malloc(FILENAME_BUF_SIZE);if(converted_filename_cp == NULL) { printf("cannot allocate memory.\n"); exit(1);}
	char *normalized_filename_cp;normalized_filename_cp = (char *)malloc(FILENAME_BUF_SIZE);if(normalized_filename_cp == NULL) { printf("cannot allocate memory.\n"); exit(1);}
  	char *original_filename_cp;original_filename_cp= (char *)malloc(FILENAME_BUF_SIZE);if(original_filename_cp == NULL) { printf("cannot allocate memory.\n"); exit(1);}//2006,7,23

	int last_dir_int=0;
  	for(unsigned int tmp_dir_int=0;tmp_dir_int<strlen(argv[argc-1]);tmp_dir_int++){
    	if(argv[argc-1][tmp_dir_int]==0x5c){last_dir_int=tmp_dir_int;}
  	}

 	strcpy(original_filename_cp,argv[argc-1]);//2006,7,23

 	strcpy(ffted_filename_cp,argv[argc-1]);
  	strcpy(converted_filename_cp,argv[argc-1]);
  	ffted_filename_cp[last_dir_int+1]=0x00;
  	converted_filename_cp[last_dir_int+1]=0x00;
  	strcat(ffted_filename_cp,"ffted.tmp");
  	strcat(converted_filename_cp,"converted.raw");
//  	strcpy(converted_filename_cp,"s:\\converted.raw");

	last_dir_int=0;
  	for(unsigned int tmp_dir_int=0;tmp_dir_int<strlen(argv[argc-1]);tmp_dir_int++){
    	if(argv[argc-1][tmp_dir_int]==0x2e){last_dir_int=tmp_dir_int;}
  	}
  	strcpy(normalized_filename_cp,argv[argc-1]);
  	normalized_filename_cp[last_dir_int]=0x00;


//	printf("div_exp_int %d    div_exp_cp %s\n",div_exp_int,div_exp_cp);getch();

	fft_soundfile(original_filename_cp,ffted_filename_cp,argv[0],overtimes_int,tap_exp_int,div_int,1);
	double out_wave_absmax_dbl=ifft_soundfile(original_filename_cp,ffted_filename_cp,converted_filename_cp,argv[0],overtimes_int,tap_exp_int,div_int,cosine_rolloff_factor_dbl);//x4 t25 tdiv9 opt1
	remove(ffted_filename_cp);

//	out_wave_absmax_dbl/=65536;// test

	char gain_cp[]="01234567890123456789";
	if(gain_dbl>0){
  		sprintf( gain_cp , "%lg" , 
  			( (double)1-( ((double)tpdf_peak_24bitLSB_int)+nyquist_dither_peak_24bitLSB_dbl+random_dither_peak_24bitLSB_dbl)
  			*pow(2,1-OUTPUT_BITS_PER_SAMPLE) ) *gain_dbl  
  		);
	}else{
		sprintf( gain_cp , "Nrm" );
	}

  	strcat(normalized_filename_cp,SUFFIX);	strcat(normalized_filename_cp,overtimes_cp);
  	strcat(normalized_filename_cp,".t");			strcat(normalized_filename_cp,tap_exp_cp);
  	
	if(tpdf_peak_24bitLSB_int>0){	strcat(normalized_filename_cp,SUF_TPDF);	strcat(normalized_filename_cp,tpdf_peaklevel_24LSB_cp);}

	if(nyquist_dither_peak_24bitLSB_dbl!=0){
		strcat(normalized_filename_cp,".Nd");strcat(normalized_filename_cp,nyquist_dither_peak_24bitLSB_cp);
	}
	if(random_dither_peak_24bitLSB_dbl!=0){
		strcat(normalized_filename_cp,".Rd");strcat(normalized_filename_cp,random_dither_peak_24bitLSB_dbl_cp);
	}

//  	strcat(normalized_filename_cp,".div2^");	strcat(normalized_filename_cp,div_exp_cp);
//  	 	strcat(normalized_filename_cp,"+1");
  	strcat(normalized_filename_cp,".g");		strcat(normalized_filename_cp,gain_cp);
  	strcat(normalized_filename_cp,".wav");
	
//	printf("%s",normalized_filename_cp);
//	getch();
//	double out_wave_absmax_dbl=pow(2,23);//test

	if(gain_dbl > 0){    out_wave_absmax_dbl=pow(2,tap_exp_int+5)/gain_dbl*pow(2,26-tap_exp_int);}
	

//	out_wave_absmax_dbl/=8;

//	printf("\nND:%lg RD:%lg\n",nyquist_dither_peak_24bitLSB_dbl,random_dither_peak_24bitLSB_dbl);
//	getch();
	
	normalize_soundfile(converted_filename_cp,normalized_filename_cp,original_filename_cp,out_wave_absmax_dbl,overtimes_int,forced_overtimes_int,tpdf_peak_24bitLSB_int,nyquist_dither_peak_24bitLSB_dbl,random_dither_peak_24bitLSB_dbl);
//	normalize_soundfile(converted_filename_cp,normalized_filename_cp,original_filename_cp,pow(2,tap_exp_int+5)/0.75,overtimes_int,forced_overtimes_int,tpdf_peak_24bitLSB_int);

	remove(converted_filename_cp);
	return 1;
}


